#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <stdlib.h>

#include "busy.h"

static near void binkGetLine()
{
  static const size = sizeof( line );

  tag = ' ';
  stamp = 0;

  while( tag==' ' && !feof(logFile) && !ferror(logFile) )
  {

    memset( line, 0, size );

    fgets( line, size, logFile );
    progressBar();

    line[ size-1 ]=0;
    tag = *line;
    int len = strlen( line );

    printLine( line );

    if( len>=17 )
    {
      if( line[ len-1 ]=='\n' )
      {
	line[ len-1 ] = 0;
	logLines++;
      }
    }
    else
    {
      if( *line )
      {
	printf( "*Warning* Too short line %lu skipped\n", logLines );
        printLine();
      }
      tag = ' ';
      continue;
    }

    int month = getMonth( line+5 );

    if( !(isdigit(line[9]) && isdigit(line[10]) &&
	isdigit(line[12]) && isdigit(line[13]) &&
	isdigit(line[15]) && isdigit(line[16]) &&
	line[11]==':' && line[14]==':' &&
	isdigit(line[2]) && isdigit(line[3]) && month) )
    {
      printf( "*Warning* Illegal time format in line %lu\n", logLines );
      printLine();
      tag = ' ';
      continue;
    }

    struct date d, d1;
    struct time t;

    t.ti_hund = 0;
    t.ti_hour = number( line+9 );
    t.ti_min = number( line+12 );
    t.ti_sec = number( line+15 );
    d.da_mon = month;
    d.da_day = number( line+2 );

    getdate( &d1 );
    d.da_year = d1.da_year;
    if( d1.da_mon<month )
      d.da_year--;

    big isTime = dostounix( &d, &t );

    if( isTime<=hystHeader.date )
    {
      skipLines++;
      tag = ' ';
      startTime = isTime;
      continue;
    }

    memcpy( logEnd, line+2, sizeof(logEnd)-1 );
    logEnd[ sizeof(logEnd)-1 ] = 0;

    if( !*logStart )
      strcpy( logStart, logEnd );

    endTime = isTime;

    if( !startTime )
      startTime = endTime;

    stamp = endTime;
    strcpy( line, line+23 );

    if( tag=='@' || tag=='!' )
      tag = ' ';

  }

  if( feof(logFile) )
    progressBar();

}

static near prsState binkPrsBeginTry( int skp=1 )
{

  register char tag = ::tag;

  if( tag=='#' && begin( line, "RING" ) )
    return Answering;

  if( tag==':' && begin( line, "DIALING" ) )
    return Dialing;

  if( tag==':' && begin( line, "Received mail" ) )
    return receivedMail;

  if( tag==':' && begin( line, "Executing" ) )
    return Executing;

  if( tag==':' && begin( line, "Exit after receiving mail" ) )
    return eventExit;

  if( tag==':' && begin( line, "Function key exit" ) )
    return eventExit;

  if( tag==':' && begin( line, "Shelling to DOS" ) )
    return eventExit;

  if( tag==':' && begin( line, "Detected file" ) && end( line, ", exiting" ) )
    return eventExit;

  if( tag==':' && begin( line, "Exit requested" ) )
    return skipLine;
//    return eventExit;

  if( tag==':' && begin( line, "Starting Event" ) )
    return skipLine;

  if( tag=='#' && begin( line, "Connect" ) )
  {
    getSkip = 1;
    return Answering;
  }

  if( skp && tag=='+' && begin( line, "begin," ) )
    return skipLine;

  if( skp && tag=='+' && begin( line, "end," ) )
    return skipLine;

  if( tag=='+' && begin( line, "Killed" ) )
    return skipLine;

  if( tag=='#' && begin( line, "BUSY" ) )
    return skipLine;

  if( tag=='#' && begin( line, "No Carrier" ) )
    return skipLine;

  if( tag=='*' && begin( line, "Session with" ) )
    return skipLine;

  if( tag==':' && begin( line, "Exiting on uninitialized" ) )
    return skipLine;

  if( tag=='#' && begin( line, "exit on event" ) )
    return eventExit;

  if( tag==':' && begin( line, "Entering POLL Mode" ) )
    return skipLine;

  if( tag==':' && begin( line, "Poll completed" ) )
    return skipLine;

  if( tag==':' && begin( line, "Entering terminal Mode" ) )
    return terminalCalled;

  if( tag==':' && begin( line, "Compiled" ) )
    return skipLine;

  if( tag==':' && begin( line, "Repacking" ) )
    return skipLine;

  if( tag=='#' && begin( line, "Noise from modem" ) )
    return skipLine;

  return noAction;
}

static near void binkPrsBegin()
{
  actionStarted = stamp;
  state = noAction;

  if( tag=='*' && begin( line, "Lost carrier" ) )
    state = skipLine;
  else
    if( tag=='#' && begin( line, "No Dialtone" ) )
      state = skipLine;
    else
      if( tag=='#' && begin( line, "No Carrier" ) )
	state = skipLine;
      else
	if( tag=='#' && begin( line, "Busy" ) )
	  state = skipLine;
	else
	  if( tag=='#' && begin( line, "Dialing" ) )
	    state = skipLine;
	  else
	    state = binkPrsBeginTry();

  if( !state )
  {
    printf( "*Error* Unknown action beginning at line %lu\n", logLines );
    printLine();
  }
}

static near void binkPrsDialing()
{

  outSessions++;

  for( ;; )
  {
    if( tag!='#' )
    {
      getSkip = 1;
      state = noAction;
      break;
    }
    else
      if( begin( line, "CONNECT" ) )
      {
	state = Outcoming;
	break;
      }
      else
	if( binkPrsBeginTry() )
	{
	  getSkip = 1;
	  state = noAction;
	  break;
	}
	else
	  if( !(begin( line, "Dial" ) || begin( line, "Dialing" ) ||
	    begin( line, "RRING" ) || begin( line, "RINGING" ) ||
	    begin( line, "No Dial") ||begin( line, "No Dialtone")) )
	  {
	    state = noAction;
	    break;
	  }
    binkGetLine();
  }

  if( tag!=' ' )
    totalDialing += registerTime( stamp-actionStarted, Dialing );
  actionStarted = stamp;

}

static near big binkPrsSessionFileSize( FileType& fileType )
{
  big bytes = 0;
  register char *lp = strrchr( line, '(' );

  if( lp!=NULL && isdigit(*(lp+1)) )
    bytes = atol( lp+1 );
  else
  {
    printf( "*Error* Can't decode file length at line %lu - unknown line structure\n", logLines );
    printLine();
  }

  fileType = Undefined;

  if( *(lp-1)!=' ' && *(lp-5)!='.' )
cant_type:
  {
    printf( "*Error* Can't decode file type at line %lu - unknown line structure\n", logLines );
    printLine();
  }
  else
  {

    lp -= 4;

    switch( toupper(*lp)+(toupper(*(lp+1))<<8) )
    {

    case 'MO':
    case 'WE':
    case 'TU':
    case 'FR':
    case 'TH':
    case 'SA':
    case 'SU':

      fileType = Xmail;
      break;

    case 'PK':

     if( begin( line, "Receiving" ) )

       if( toupper(*(lp+2))=='T' )
         fileType = Mail;
       else
         fileType = Files;

     else
     {
       register char *arrow( strstr( line, "->") );

       if( toupper(*(lp+2))=='T' && arrow!=NULL )

         if( *(arrow-5)=='.' && *(arrow-1)==' ' )

           if( begin( arrow-4, "AUT" ) )
             fileType = Files;
	   else
             fileType = Mail;

         else

           goto cant_type;

       else

         fileType = Files;

       }

     break;

    default:

      fileType = Files;

    }

  }

  return bytes;

}

static near void binkPrsSession()
{
  big inTraf( 0 ),
      outTraf( 0 ),
      curIn( 0 ),
      curOut( 0 );

  big inMailL( 0 ),
      inXmailL( 0 ),
      inFilesL( 0 ),
      outMailL( 0 ),
      outXmailL( 0 ),
      outFilesL( 0 ),
      startIn( 0 ),
      startOut( 0 ),
      usedTime( 0 );

  FileType fileTypeIn( Undefined ),
	   fileTypeOut( Undefined );

  SessionType sesType( WhoKnown );

  index curNode( 0xffff );
  big startLine( logLines );

  for( ;; )
  {

    if( tag==' ' || binkPrsBeginTry() )
    {
      getSkip = 1;
      break;
    }

    if( ( tag=='*' && begin( line, "End of" ) ) ||
	( tag=='*' && begin( line, "Session with" ) ) )
    {

      if( begin( line+7, "EMSI" ) )
	sesType = EMSI;

      if( begin( line+7, "WaZOO" ) )
        sesType = WaZOO;

      if( begin( line+7, "FTS-0001" ) )
        sesType = FTS0001;

      break;

    }

    if( tag==':' && begin( line, "Exiting to BBS" ) )
    {
      state = BBS;
      return;
    }

    if( tag==':' && begin( line, "Spawning BBS" ) )
    {
      state = BBS1;
      return;
    }

    if( tag==' ' && begin( line, "Called for BBS" ) )
    {
      state = noAction;
      return;
    }

    if( tag=='*' && begin( line, "Intro:" ) )
      tag=0;

    if( tag=='+' && begin( line, "Sent-" ) )
    {

      if( !curOut )
      {
	printf( "*** Internal error: Zero sent file length at %lu line\n"
		"    Strange! Please report to John.\n", logLines );
	printLine();
      }

//      usedTime += stamp-startOut;
//      startOut = 0;
      startOut = stamp;
      outTraf += curOut;

      switch( fileTypeOut )
      {
      case Mail:
	outMailL += curOut;
	break;
      case Xmail:
	outXmailL += curOut;
	break;
      case Files:
	outFilesL += curOut;
	break;
      default:
	printf( "*** Internal error: Illegal sent file type at %lu line\n"
		"    Strange! Please report to John.\n", logLines );
	printLine();
      }

      fileTypeOut = Undefined;
      curOut = 0;

    }

    if( tag=='+' && begin( line, "Received-" ) )
    {

      if( !curIn )
      {
	printf( "*** Internal error: Zero received file length at %lu line\n"
		"    Strange! Please report to John.\n", logLines );
	printLine();
      }

//      usedTime += stamp-startIn;
//      startIn = 0;
      startOut = stamp;
      inTraf += curIn;

      switch( fileTypeIn )
      {
      case Mail:
	inMailL += curIn;
	break;
      case Xmail:
	inXmailL += curIn;
	break;
      case Files:
	inFilesL += curIn;
	break;
      default:
	printf( "*** Internal error: Illegal received file type at %lu line\n"
		"    Strange! Please report to John.\n", logLines );
	printLine();
      }

      fileTypeIn = Undefined;
      curIn = 0;

    }

    if( tag=='#' && begin( line, "Sending" ) )
    {
      curOut = binkPrsSessionFileSize( fileTypeOut );
//      startOut = stamp;
      if( !startIn )       // new
	startIn = stamp;
    }

    if( tag=='#' && begin( line, "Receiving" ) )
    {
      curIn = binkPrsSessionFileSize( fileTypeIn );
//      startIn = stamp;
      if( !startIn )       // new
	startIn = stamp;
    }

    if( tag==':' && begin( line, "WaZOO method" ) )
    {
      sesType = WaZOO;
      registerIO( line+14 );
    }

    if( tag==':' && begin( line, "EMSI method" ) )
    {
      sesType = EMSI;
      registerIO( line+13 );
    }

    if( tag==':' && begin( line, "FTS-0001 session" ) )
    {
      sesType = FTS0001;
      registerIO( "XModem" );                //???????
    }

    if( tag==':' && begin( line, "Phone:" ) )
      sesType = EMSI;

    if( tag==':' && begin( line, "Flags:" ) )
      sesType = EMSI;

    if( tag==':' && begin( line, "Time:" ) )
      sesType = EMSI;

    if( tag==':' && begin( line, "Aka:" ) )
      sesType = EMSI;

    if( tag==':' && begin( line, "Addon" ) )
      sesType = EMSI;

    if( curNode==0xffff )
      if( tag=='*' )
      {
	char *lp = strrchr( line, '(' );
	char *rp = NULL;

	if( lp!=NULL )
	  rp = strchr( lp, ')' );

	if( rp!=NULL )
	{
	  char *addr = new char [int(rp-lp)+1];

	  checkPtr( addr );

	  *rp = 0;
	  strcpy( addr, lp+1 );

	  unsigned short zone, net, node, point;
	  char *domain;

	  checkAddress( addr, zone, net, node, point, &domain );

	  for( curNode=0; curNode<totalNodes; curNode++ )
	    if( nodesInfo[curNode]->point==point &&
		nodesInfo[curNode]->node==node &&
		nodesInfo[curNode]->net==net &&
		nodesInfo[curNode]->zone==zone &&
                !stricmp( nodesInfo[curNode]->domain, domain ) )
	      break;

	  if( curNode==totalNodes )
	  {

            if( totalNodes==MaxItems )
            {
              printf( "*Fatal* Too many nodes! Support up to %u nodes.\n"
                      "        Sorry! Program aborted at line %lu :(\n", MaxItems, logLines );
	      printLine();
              returnToDos( 1 );
            }

	    curNode=totalNodes++;

	    nodesInfo = (NodeInfo **)realloc( nodesInfo,
	      totalNodes*sizeof(NodeInfo **) );
	    checkPtr( nodesInfo );

	    NodeInfo *newNode( new NodeInfo );
	    checkPtr( newNode );

	    memset( newNode, 0, sizeof(NodeInfo) );
	    nodesInfo[curNode] = newNode;

	    newNode->domain = new char[ strlen(domain) +1 ];
	    checkPtr( newNode->domain );
	    strcpy( newNode->domain, domain );

	    newNode->zone=zone;
	    newNode->net=net;
	    newNode->node=node;
	    newNode->point=point;

	  }

	}

      }

    binkGetLine();

  }

  if( tag!=' ' )

    if( state==Incoming )
    {
      totalIncome += registerTime( stamp-actionStarted, Incoming );
      if( curNode!=0xffff )
	nodesInfo[curNode]->income += stamp-actionStarted;
    }
    else
    {
      totalOutcome += registerTime( stamp-actionStarted, Outcoming );
      if( curNode!=0xffff )
	nodesInfo[curNode]->outcome += stamp-actionStarted;
    }

  totalBytesIn += inTraf;
  inMail += inMailL;
  inXmail += inXmailL;
  inFiles += inFilesL;
  totalBytesOut += outTraf;
  outMail += outMailL;
  outXmail += outXmailL;
  outFiles += outFilesL;

  if( startIn && startOut )
    usedTime = startOut - startIn;

  if( curNode!=0xffff )
  {

    nodesInfo[curNode]->received += inTraf;
    nodesInfo[curNode]->inMail += inMailL;
    nodesInfo[curNode]->inXmail += inXmailL;
    nodesInfo[curNode]->inFiles += inFilesL;

    nodesInfo[curNode]->sent += outTraf;
    nodesInfo[curNode]->outMail += outMailL;
    nodesInfo[curNode]->outXmail += outXmailL;
    nodesInfo[curNode]->outFiles += outFilesL;

    nodesInfo[curNode]->ioTime += usedTime;

    if( state==Incoming )
    {
      inHand++;
      nodesInfo[curNode]->inSession++;
    }
    else
    {
      outHand++;
      nodesInfo[curNode]->outSession++;
    }

    switch( sesType )
    {
    case EMSI:
      sesEMSI++;
      break;
    case WaZOO:
      sesWaZOO++;
      break;
    case FTS0001:
      sesFTS0001++;
      break;
    default:
      printf( "*Warning* Unknown session type started at line %lu, forced to WaZOO\n", startLine );
      sesWaZOO++;
    }

  }

  else
    if( inTraf+outTraf )
      printf("*** Internal error: nonzero traffic with undetected nodes at line %lu\n"
	     "    Strange! Please report to John.\n", startLine );

  state = noAction;
}

static near int binkPrsAnsweringCrazy()
{
  int ok( 0 );

  char *newLine = new char[ strlen(line)+1 ];

  checkPtr( newLine );
  strcpy( newLine, line );

  if( tag=='*' )
  {
    char *lp = strrchr( newLine, '(' );
    char *rp = NULL;

    if( lp!=NULL )
      rp = strchr( lp, ')' );

    if( rp!=NULL )
    {
      char *addr = new char [int(rp-lp)+1];

      checkPtr( addr );

      *rp = 0;
      strcpy( addr, lp+1 );

      unsigned short zone, net, node, point;
      char *domain;

      ok = checkAddress( addr, zone, net, node, point, &domain, 0 );

      delete addr;

    }

  }

  delete newLine;

  return ok;
}

static near void binkPrsAnswering()
{
  inSessions++;

  char crazy( 0 );

  for( ;; )
  {

    if( binkPrsAnsweringCrazy() )
    {
      crazy = 1;
      getSkip = 1;
      state = Incoming;
      break;
    }

    if( tag!=':' || !begin( line, "Incoming call," ) )
      if( tag!='#' )
      {
	 getSkip = 1;
	 state = noAction;
	 break;
      }
      else
	if( begin( line, "CONNECT" ) )
	{
	  state = Incoming;
	  break;
	}
	else
//	  if( tag==' ' )
	  {
	    getSkip = 1;
	    state = noAction;
	    break;
	  }
//	  else
//	  {
//	    state = noAction;
//	    break;
//	  }

    binkGetLine();

  }

  int need( begin( line, "Connect" )||begin( line, "No Carrier" ) );

  if( tag!=' ' && (need || crazy) )
    totalAnswering += registerTime( stamp-actionStarted, Answering );
  actionStarted = stamp;

}

static near void binkPrsExecuting()
{
  if( tag!=':' || !begin( line, "Bink/+ Reactivated" ) )
    getSkip = 1;

  totalExternal += registerTime( stamp-actionStarted, Executing );
  state = noAction;

}

static near void binkPrsMail()
{
  if( tag!='#' || !begin( line, "Re-enabling system" ) )
    getSkip = 1;

  totalExternal += registerTime( stamp-actionStarted, receivedMail );
  state = noAction;

}

static near void binkPrsEventExit()
{
  for( ;; )
  {

    if( tag=='+' && begin( line, "begin," ) )
      break;
    else
      if( tag==' ' || binkPrsBeginTry( 0 ) )
      {
	getSkip = 1;
	state = noAction;
	break;
      }

    binkGetLine();

  }

  if( tag!=' ' )
    totalExternal += registerTime( stamp-actionStarted, eventExit );

  state = noAction;
}

static near void binkPrsTerminal()
{
  for( ;; )
  {

    if( tag=='+' && begin( line, "begin," ) )
      break;
    else
      if( tag==' ' )
      {
	getSkip = 1;
	state = noAction;
	break;
      }

    binkGetLine();

  }

  if( tag!=' ' )
    totalTerminal += registerTime( stamp-actionStarted, terminalCalled );

  state = noAction;
}

static near void binkPrsBBS()
{
  for( ;; )
  {

    if( tag=='+' && begin( line, "begin," ) )
      break;
    else
      if( tag==' ' || binkPrsBeginTry( 0 ) )
      {
	getSkip = 1;
	break;
      }

    binkGetLine();

  }

  if( tag!=' ' )
    totalBBS += registerTime( stamp-actionStarted, BBS );

  state = noAction;
}

static near void binkPrsBBS1()
{
  if( !(tag==':' && begin( line, "Returned from BBS" )) )
    getSkip = 1;

  totalBBS += registerTime( stamp-actionStarted, BBS );
  state = noAction;
}

void binkParser()
{
  printf( "Processing Bink/+ LOG `%s'", logName );

  state = noAction;

  for( ;; )
  {

    if( getSkip )
      getSkip = 0;
    else
      binkGetLine();

    if( tag==' ' )
      break;

    switch( state )
    {

    case noAction:
      binkPrsBegin();
      break;

    case Answering:
      binkPrsAnswering();
      break;

    case Dialing:
      binkPrsDialing();
      break;

    case Incoming:
    case Outcoming:
      binkPrsSession();
      break;

    case receivedMail:
      binkPrsMail();
      break;

    case skipLine:
      state = noAction;
      getSkip = 1;
      break;

    case Executing:
      binkPrsExecuting();
      break;

    case eventExit:
      binkPrsEventExit();
      break;

    case terminalCalled:
      binkPrsTerminal();
      break;

    case BBS:
      binkPrsBBS();
      break;

    case BBS1:
      binkPrsBBS1();
      break;

    default:
      printf( "*Fatal* unknown parser state %d at line %lu\n", state, logLines );
      printLine();
      state = noAction;

    }

  }

  if( needProgressBar )
    printf( "      \n" );

  if( state!=noAction && state!=skipLine )
  {
    printf( "*Error* Incomplete file, parser finished with %d state\n", state );
    printLine();
  }

}

