#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <dir.h>
#include <share.h>
#include <io.h>
#include <conio.h>

#if !defined(__OS2__)
#include <alloc.h>
#endif

#include "busy.h"

// V8 egrep-style regular expression

extern char *regErrorMsg;

//  Command line parser declaration

extern int optopt, optind;
extern char *optarg;

extern "C" int getopt( int, char * const *, const char * );

char *strTime( big elapsed )
{
  char *r = new char[ 32 ],
       w[ 32 ] = {0};

  int secs( int(elapsed%60) ),
      mins( int( (elapsed/60)%60 ) ),
      hours( int( (elapsed/60/60)%24 ) ),
      days( int( elapsed/60/60/24 ) );

  checkPtr( r );
  *r = 0;

  if( days )
  {
    sprintf( w, "%d-", days );
    strcat( r, w );
  }

  if( hours )
  {
    sprintf( w, "%02d:", hours );
    strcat( r, w );
  }

  sprintf( w, "%02d:%02d", mins, secs );
  strcat( r, w );

  return r;
}

char *strBig( double dsize )
{
  char *r = new char[ 64 ];

  checkPtr( r );

  if( dsize<1000 )
    sprintf( r, "%u", int(dsize) );
  else
  {
    int len;

    dsize /= 1024;

    if( dsize<1000 )
      len = sprintf( r, "%.1fK", dsize );
    else
      len = sprintf( r, "%.1fM", dsize/1024 );

    if( r[len-2]=='0' )
    {
      r[len-3]=r[len-1];
      r[len-2]=0;
    }

  }

  return r;
}

big timeMark()
{
  struct date d;
  struct time t;

  gettime( &t );
  getdate( &d );

  return dostounix( &d, &t );
}

big startRunTime = timeMark();

void progressBar()
{

  int curPercent = int( double( ftell( logFile ) )/fileSize*100 );

  if( curPercent!=oldPercent )
  {
    oldPercent = curPercent;
#if !defined(__OS2__)
    checkPoint();
#endif

    if( needProgressBar )
      printf( " %3d%%\b\b\b\b\b", curPercent );
  }

}

void capitalize( char *originName )
{
  strlwr( originName );

  for( int i(0), cap(1); originName[i]; i++ )
  {
    if( cap && isalpha( originName[i] ) )
    {
      originName[i] = toupper( originName[i] );
      cap = 0;
    }

    cap = !isalpha( originName[i] );
  }

}

void checkPtr( void *addr )
{

  if( addr==NULL )
  {
    printf( "*Fatal* Memory overflow - program aborted at line %d\n", logLines );
    printLine();
    returnToDos( 2 );
  }

}

int begin( register char *orig, register char *patt )
{

  for( ; *patt&&*orig; orig++, patt++ )
    if( toupper( *orig )!=toupper( *patt ) )
      return 0;

  return 1;

}

int end( char *orig, char *patt )
{

  register int origLen( strlen(orig) ),
	       pattLen( strlen(patt) );

  if( pattLen>origLen )
   return 0;

  return begin( orig+origLen-pattLen, patt );

}

int getMonth( char *p )
{

  for( register int i=0; i<12; i++ )
    if( begin( p, monthName[i] ) )
      return i+1;

  return 0;

}

const char * const suff( int n )
{

  static char *no="", *yes="s";

  return n==1 ? no : yes;

}

big registerTime( big time, prsState state ){

  if( long(time)<0 )
    return 0;

  big how( time ),
      cur,
      from( actionStarted ),
      begin( actionStarted );
  struct time t;
  struct date d;

  unixtodos( begin, &d, &t );
  t.ti_hund = 0;
  t.ti_sec = 0;
  t.ti_min /= 30;
  int i = t.ti_hour*2 + t.ti_min;
  t.ti_min *= 30;

  begin = dostounix( &d, &t );

  while( how )
  {

    if( how>begin+30*60-from )
      cur = begin+30*60-from;
    else
      cur = how;

    switch( state )
    {

    case Answering:
      info[i].answer += cur;
      break;

    case Dialing:
      info[i].dial += cur;
      break;

    case Incoming:
      info[i].income += cur;
      break;

    case Outcoming:
      info[i].outcome += cur;
      break;

    case Executing:
    case receivedMail:
    case eventExit:
      info[i].external += cur;
      break;

    case BBS:
      info[i].bbs += cur;
      break;

    case terminalCalled:
      info[i].terminal += cur;
      break;

    default:
      printf( "*** Internal error: unknown parser state %d in %lu line for registerTime()\n"
	      "    Time interval skipped, please report to John.\n", state, logLines );
      printLine();
      completeCode = 100;
    }

    if( ++i==48 )
      i = 0;

    begin += 30*60;
    how -= cur;
    from = begin;

  }

  return time;

}

void illegalAddress()
{

  printf( "*Error* Invalid address format in line %lu\n", logLines );
  printLine();
  completeCode = 100;

}

void checkDomain( char *dom )
{

  capitalize( dom );

  if( begin( dom, "fidonet" ) )
    dom[7] = 0;

}

int checkAddress( char *addr, unsigned short& zone, unsigned short& net,
		   unsigned short& node, unsigned short& point,
		   char **domain, char flag )
{
  unsigned short num;
  char *term( NULL );
  static char empty[] = "Fidonet";

  zone = net = node = point = 0;
  *domain = empty;

  char state( 0 ),
       fail( 0 );

  for( ;; addr = term+1 )
  {
    num = (unsigned short)strtoul( addr, &term, 10 );

    switch( *term )
    {
     case ':':
       zone = num;
       state = 1;
       break;
     case '/':
       net = num;
       state = 2;
       break;
     case '.':
       node = num;
       state = 3;
       break;
     case 0:
     case '@':
       switch( state )
       {
       case 0:
	 node = num;
	 if( flag )
	   illegalAddress();
	 else
	   fail = 1;
	 break;
       case 1:
	 net = num;
	 if( flag )
	   illegalAddress();
	 else
	   fail = 1;
	 break;
       case 2:
	 node = num;
	 break;
       case 3:
	 point = num;
	 break;
       }
       if( *term=='@' )
	 *domain = term+1;
       checkDomain( *domain );
       return fail ? 0 : 1;
     default:
       if( flag )
	 illegalAddress();
       else
	 fail = 1;
       checkDomain( *domain );
       return fail ? 0 : 1;
    }

  }

//  return fail ? 0 : 1;

}

void registerIO( char *protocol )
{

  for( int curIO=0; curIO<totalIO; curIO++ )
    if( !stricmp( ioInfo[curIO]->name, protocol ) )
      break;

  if( curIO==totalIO )
  {

    if( totalIO==MaxItems )
    {
      printf( "*Fatal* Too many protocols! Support up to %u protocols.\n"
              "        Sorry! Program aborted at line %lu :(\n", MaxItems, logLines );
      printLine();
      returnToDos( 3 );
    }

    curIO=totalIO++;

    ioInfo = (IOInfo **)realloc( ioInfo, totalIO*sizeof(IOInfo **) );
    checkPtr( ioInfo );

    IOInfo *newIO( new IOInfo );
    checkPtr( newIO );

    ioInfo[curIO] = newIO;

    newIO->name = new char[ strlen(protocol) +1 ];
    checkPtr( newIO->name );
    strcpy( newIO->name, protocol );

    newIO->count =  0;

  }

  ioInfo[curIO]->count++;

}

int Cdecl addrCmp( const void *i1, const void *i2 )
{
  int r=0;
  NodeInfo *n1( *(NodeInfo **)i1 ),
	   *n2( *(NodeInfo **)i2 );

/*
    r =  stricmp( n1->domain, n2->domain );
    if( r )
      return r;
*/

    r = n1->zone - n2->zone;
    if( r )
      return r;

    r = n1->net - n2->net;
    if( r )
      return r;

    r = n1->node - n2->node;
    if( r )
      return r;

    r = n1->point - n2->point;
    if( r )
      return r;

  return r;
}

int Cdecl ioCmp( const void *i1, const void *i2 )
{
  return int( (*(IOInfo **)i2)->count - (*(IOInfo **)i1)->count );
}

int Cdecl io1Cmp( const void *i1, const void *i2 )
{
  return stricmp( (*(IOInfo **)i1)->name, (*(IOInfo **)i2)->name );
}


static near void compileMask( char *optarg )
{

  for( int i=0; optarg[i]; i++ )
    if( optarg[i]=='!' )
      optarg[i] = '|';

  if( (nodeMask= regcomp( optarg ))==NULL )
  {
    printf( "*Fatal* %s in `%s'\n", regErrorMsg, optarg );
    returnToDos( 4 );
  }

}

static near int parseOption( int flag, int argn, char **argc )
{
  char *optUsed( "1zh:m:o:a:r:btsf:l:j:p:n:u:c:" );

  if( !flag )
    optUsed += 4;

  int option;

  while( (option=getopt( argn, argc, optUsed ))!=-1 )
    switch( option )
    {
    case '1':
      newTMail = 1;
      break;

    case 'z':
      needProgressBar = 1;
      break;

    case 'n':
      toAddr = optarg;
      break;

    case 'f':
      fromName = optarg;
      break;

    case 'l':
      toName = optarg;
      break;

    case 'j':
      subjField = optarg;
      break;

    case 'p':
      msgBase = optarg;
      break;

    case 'b':
      useHysto = 0;
      break;

    case 's':
      useTraff = 0;
      break;

    case 't':
      useSess = 0;
      break;

    case 'h':
      hystName = optarg;
      capitalize( hystName );
      break;

    case 'o':
      statName = optarg;
      capitalize( statName );
      break;

    case 'a':
      myAddress = optarg;
      break;

    case 'r':
      originName = optarg;
      capitalize( originName );
      break;

    case 'm':
      compileMask( optarg );
      break;

    case 'u':
      capitalize( optarg);
      if( !stricmp( optarg, "msg" ) )
	storageType = FidoMsg;
      else
	if( !stricmp( optarg, "jam" ) )
	  storageType = JAMMsg;
	else
	{
	  printf( "*Fatal* Unknown storage `%s'\n", optarg );
	  return 2;
	}
      break;

    case 'c':
      {
	for( int i(0); optarg[i]; i++ )
	  if( optarg[i]!='-' )
	    switch( i )
	    {
	    case 0:
	      sesChar = optarg[0];
	      break;

	    case 1:
	      conChar = optarg[1];
	      break;

	    case 2:
	      extChar = optarg[2];
	      break;

	    case 3:
	      bbsChar = optarg[3];
	      break;

	    case 4:
	      trmChar = optarg[4];
	      break;

	    default:
	      printf( "*Warning* Too long -c argument `%s'\n", optarg );
	      goto no_more_need;
	    }
      }
no_more_need:
      break;

    default:
      putchar( '\n' );
      return 2;
    }

  char *qqError;

  if( storageType )
  {

    if( msgBase==NULL )
    {
      switch( storageType )
      {
      case JAMMsg:
        qqError = "JAM-base generic file name";
        break;
      case FidoMsg:
        qqError = "Fido style msgbase path";
      }

not_specified:
      printf( "*Fatal* %s not specified!\n\n", qqError );
      return 2;
    }

    if( myAddress==NULL )
    {
need_address:
      qqError = "Address";
      goto not_specified;
    }

/*
    if( originName==NULL )
    {
      qqError = "Origin file";
      goto not_specified;
    }
*/

    if( statName!=NULL )
    {
      printf( "*Fatal* Output file and storage type specified!\n\n" );
      return 2;
    }
    else
    {
      statName = new char[16];
      sprintf( statName, "%08x.tmp", time( NULL ) );
      capitalize( statName );
    }

  }

  if( originName!=NULL && myAddress==NULL )
    goto need_address;

  if( myAddress!=NULL )
  {
    char *domain;
    unsigned short zone, net, node, point;
    qqError = myAddress;

    if( !checkAddress( myAddress, zone, net, node, point, &domain, 0 ) )
    {
illegal_address:
      printf( "*Fatal* Illegal address format `%s'!\n\n", qqError );
      return 2;
    }

  }

  if( toAddr!=NULL )
  {
    char *domain;
    unsigned short zone, net, node, point;
    qqError = toAddr;

    if( !checkAddress( toAddr, zone, net, node, point, &domain, 0 ) )
      goto illegal_address;

  }

  if( optind>=argn )
  {
    qqError = "Input file";
    goto not_specified;
  }

  char *inputName = argc[optind];

  capitalize( inputName );

  if( optind+1<argn )
  {
    printf( "*Fatal* Too many input files specified!\n\n" );
    return 2;
  }

  char drive[MAXDRIVE], dir[MAXDIR], name[MAXFILE], ext[MAXEXT];
  fnsplit( inputName, drive, dir, name, ext );

  if( statName==NULL )
  {
    statName = new char [strlen(name)+MAXEXT+1];
    strcpy( statName, name );
    strcat( statName, ".stc" );
    capitalize( statName );
  }

  if( flag )
  {

    logName = inputName;

    if( hystName==NULL )
    {
      hystName = new char [strlen(name)+MAXEXT+1];
      strcpy( hystName, name );
      strcat( hystName, ".his" );
      capitalize( hystName );
    }

  }
  else
    hystName = inputName;

  if( originName!=NULL )
    compileOrigin();

  return 0;

}

void stripLine( register char *l )
{

  char prevSpace( 1 ),
       *cur( l ),
       *beg( l );

  for( ; *l; l++ )
    if( isspace(*l) )
    {
      if( !prevSpace )
      {
	prevSpace = 1;
	*(cur++) = ' ';
      }
    }
    else
    {
      prevSpace = 0;
      if( *l=='\n' )
	break;
      *(cur++) = *l;
    }

  while( cur!=beg )
    if( !isspace(*(--cur)) )
    {
      cur++;
      break;
    }

  *cur = 0;

}

static near LOGStyle logStyle()
{
  if( newTMail )
    return logTMStyle;

  LOGStyle retStyle( logUnknownStyle );
//  register int lineCount( 0 );

  while( !feof(logFile) && !ferror(logFile) )
  {

    fgets( line, sizeof(line), logFile );
    stripLine( line );

    if( *line )
      if( isdigit(line[9]) && isdigit(line[10]) &&
	  isdigit(line[12]) && isdigit(line[13]) &&
	  isdigit(line[15]) && isdigit(line[16]) &&
	  line[11]==':' && line[14]==':' &&
	  isdigit(line[2]) && isdigit(line[3]) &&
	  begin( line+17, " bink" ) && getMonth( line+5 ) )
      {
	retStyle = logBinkStyle;
	break;
      }
      else
	if( isdigit(line[0]) && isdigit(line[1]) &&
	    isdigit(line[3]) && isdigit(line[4]) &&
	    isdigit(line[6]) && isdigit(line[7]) &&
	    isdigit(line[9]) && isdigit(line[10]) &&
	    isdigit(line[12]) && isdigit(line[13]) &&
	    line[2]=='/' && line[5]==' ' && line[14]==' ' &&
	    line[8]==':' && line[11]==':' )
	{
	  retStyle = logTMStyle;

	  if( strstr( line, "T-Mail" )!=NULL && strstr( line, ", starting" )!=NULL )
	  {
	    newTMail = atol( line+22 ) > 2500 ? 1 : 0;
	    break;
	  }

	  if( begin( line+15, "JS-" ) || begin( line+15, "JR-" ) ||
	     begin( line+15, "Handshake:" ) )
	  {
	    newTMail = 1;
	    break;
	  }

	}
/*
	else
	  if( ++lineCount==25 )
	    break;
*/

  }

  memset( line, 0, sizeof(line) );

  fseek( logFile, 0, SEEK_SET );

  return retStyle;
}

void runStat()
{

  char stat[255];
#if !defined(__OS2__)
  void *high = sbrk(0);
#endif

  sprintf( stat, "\n%c Run statistics: time %s,"
#if !defined(__OS2__)
    " %s memory,"
#endif
    " %lu/%lu LOG lines (%s)\n",
    4,
    strTime( timeMark()-startRunTime ),
#if !defined(__OS2__)
    strBig( FP_SEG(high)*16l+FP_OFF(high)-_psp*16l ),
#endif
    logLines-skipLines,
    logLines, strBig( fileSize ) );

  printf( stat );
  putchar( '\n' );

  if( statFile!=NULL ){

    fprintf( statFile, stat );
    fprintf( statFile, "\n--- %s %s\n", progName, progVersion );

    putOrigin();

  }

}

static near int doStat( int argn, char **argc, char isBrake=0 )
{

  int ret = parseOption( 1, argn, argc );

  if( ret )
    return ret;

  logFile = _fsopen( logName, isBrake ? "rb" : "r", SH_DENYNONE );

  if( logFile==NULL )
  {
    IOerror( logName );
    completeCode = 7;
    return 0;
  }

  fileSize = filelength( fileno( logFile ) );
  oldPercent = -1;

  statFile = _fsopen( statName, "w+", SH_DENYWR );

  if( statFile==NULL )
  {
    IOerror( statName );
    completeCode = 8;
    return 0;
  }

  if( setvbuf( logFile, NULL, _IOFBF, 1024*30 ) )
    puts( "*Warning* Unable locate buffer for LOG-file\n" );

  loadHystory( hystName );

  LOGStyle curLog( isBrake ? logBrakeStyle : logStyle() );

  switch( curLog )
  {
  case logBinkStyle:
    binkParser();
    break;

  case logTMStyle:
    tmParser();
    break;

  case logBrakeStyle:
    brakeParser();
    break;

  default:
    printf( "Unknown LOG style - abort.\n" );
    completeCode = 9;
    return 0;
  }

  if( logLines<skipLines )
    skipLines=logLines;

  if( skipLines!=logLines )
  {

    updateCounters();
    dumpStat( curLog );
    updateHystory();
    storeHystory();

  }
  else
  {
    char *no = "\n%c Nothing to do!\n";

    fprintf( statFile, no, 15 );
    printf( no, 15 );
    completeCode = 10;

  }

  runStat();

  if( storageType )
  {

    switch( storageType )
    {
    case FidoMsg:
      makeMsg( msgBase, statFile, fromName, toName, subjField, myAddress, toAddr );
      break;
    case JAMMsg:
      makeJam( msgBase, statFile, fromName, toName, subjField, myAddress, toAddr );
    }

    fclose( statFile );
    unlink( statName );
  }

  return 0;
}

static near int doHelp( char *prgName )
{
    printf("Usage: %-8s [-d] Stat [-btsz -cset -hhst -mmsk -ostt [<msg>]] <log-file>\n"
           "       %-8s [-d] Brake [-btsz -cset -hhst -mmsk -ostt [<msg>]] <log-file>\n"
	   "       %-8s [-d] Summary [-bts -cset -mmsk -ostt [<msg>]] <history>\n"
	   "       %-8s [-d] Reset Pointer <history>\n"
	   "       %-8s [-d] Clear History <history>\n"
	   "       %-8s [-d] Merge History [-hhst] <hist1> <hist2> [<hist3> ...]\n"
	   "       %-8s [-d] Help\n\n"
	   "               -cset   up to 5 chars set for hystogram\n"
	   "               -hhst   use output history file `hst'\n"
	   "               -mmsk   `msk' node mask as V8 egrep-style regular expression\n"
	   "               -ostt   write statistics to file `stt'\n"
	   "               -b      don`t write busy hystogram\n"
	   "               -t      don`t write detailed traffic\n"
	   "               -s      don`t write detailed sessions statistics\n"
	   "               -z      show progress indicator\n"
	   "               -d      work in debug mode\n"
	   "               -1      force T-Mail >2501\n\n",
	   prgName, prgName, prgName, prgName, prgName, prgName, prgName );
    printf( "Press any key to continue " );
    getch();
    printf( "\r%79c\r", ' ' );
    printf("       <msg>\n\n"
	   "               -aaddr  from address `addr'\n"
           "               -ffrom  from name `from'\n"
           "               -naddr  to address `addr' (if present  - NetMail style msg)\n"
           "               -lto    to name `to'\n"
           "               -jsubj  message subject `subj'\n"
           "               -ppath  `path' is Fido msg-base or JAM-base file name\n"
	   "               -rorig  random origin file `orig'\n"
           "               -utype  storage `type' must be MSG or JAM\n"
	   "\n" );

  return 0;
}

static near int doReset( int argn, char **argc )
{
  if( argn!=3 || stricmp( argc[1], "pointer" ) )
    return 1;

  printf( "*Warning* Summary statistics may be incorrect!\n" );

  loadHystory( argc[2] );

  printf( "Storing history to file `%s'\n", argc[2] );

  hystHeader.date = 0;

  fseek( hystFile, 0, SEEK_SET );

  if( fwrite( &hystHeader, 1, sizeof(hystHeader), hystFile )!=sizeof(hystHeader) )
  {
    IOerror( "Can't store history" );
    completeCode = 5;
  }

  return 0;
}

static near int doClear( int argn, char **argc )
{
  if( argn!=3 || stricmp( argc[1], "history" ) )
    return 1;

  if( unlink( argc[2] ) )
  {
    IOerror( argc[2] );
    completeCode = 5;
  }

  loadHystory( argc[2] );

  return 0;
}

static near int doSum( int argn, char **argc )
{

  int ret = parseOption( 0, argn, argc );

  if( ret )
    return ret;

  statFile = fopen( statName, "w+" );

  if( statFile==NULL )
  {
    IOerror( statName );
    completeCode = 8;
    return 0;
  }

  loadHystory( hystName );

  startTime      = hystHeader.init          ;
  endTime        = hystHeader.date          ;
  logLines       = hystHeader.lines         ;
  fileSize       = hystHeader.size          ;
  inSessions     = hystHeader.inSessions    ;
  outSessions    = hystHeader.outSessions   ;
  inHand         = hystHeader.inHand        ;
  outHand        = hystHeader.outHand       ;
  totalDialing   = hystHeader.totalDialing  ;
  totalAnswering = hystHeader.totalAnswering;
  totalIncome    = hystHeader.totalIncome   ;
  totalOutcome   = hystHeader.totalOutcome  ;
  totalExternal  = hystHeader.totalExternal ;
  totalBytesIn   = hystHeader.totalBytesIn  ;
  totalBytesOut  = hystHeader.totalBytesOut ;
  totalBBS       = hystHeader.totalBBS      ;
  totalTerminal  = hystHeader.totalTerminal ;
  inMail         = hystHeader.inMail        ;
  inXmail        = hystHeader.inXmail       ;
  inFiles        = hystHeader.inFiles       ;
  outMail        = hystHeader.outMail       ;
  outXmail       = hystHeader.outXmail      ;
  outFiles       = hystHeader.outFiles      ;
  sesFTS0001     = hystHeader.sesFTS0001    ;
  sesWaZOO       = hystHeader.sesWaZOO      ;
  sesEMSI        = hystHeader.sesEMSI       ;

  memcpy( info, hystInfo, sizeof(info) );
  nodesInfo = hystNodes;
  ioInfo = hystIoInfo;
  totalNodes = hystTotalNodes;
  totalIO = hystTotalIO;
  memcpy( logStart, hystHeader.hLogStart, sizeof(logStart) );
  memcpy( logEnd, hystHeader.hLogEnd, sizeof(logEnd) );

  dumpStat( logUnknownStyle );
  runStat();

  if( storageType )
  {

    switch( storageType )
    {
    case FidoMsg:
      makeMsg( msgBase, statFile, fromName, toName, subjField, myAddress, toAddr );
      break;
    case JAMMsg:
      makeJam( msgBase, statFile, fromName, toName, subjField, myAddress, toAddr );
    }

    fclose( statFile );
    unlink( statName );
  }

  return 0;
}

void Cdecl main( int argn, char **argc )
{
  randomize();

  char badCommand = 1;

  printf( "\n%s %s\n\n", progName, progVersion  );
  printf( "%c Running under %s\n\n", 4, mTask->getName() );

  memset( logStart, 0, sizeof(logStart) );
  memset( logEnd, 0, sizeof(logEnd) );
  memset( info, 0, sizeof(info) );
  memset( hystInfo, 0, sizeof(hystInfo) );

  char *prgName( new char [MAXFILE] );

  checkPtr( prgName );

  {
    char *drive( new char [MAXDRIVE] ),
         *dir( new char [MAXDIR] ),
         *ext( new char [MAXEXT] );

    checkPtr( drive );
    checkPtr( dir );
    checkPtr( ext );

    fnsplit( argc[0], drive, dir, prgName, ext );

    delete drive;
    delete dir;
    delete ext;
  };

  capitalize( prgName );

  if( argn<2 )
    badCommand = 1;
  else
  {
    int off( 1 );

    if( !stricmp( argc[1], "-d" ) )
    {
      off++;
      debugMode = 1;
      printf( "*Info* Working in DEBUG mode\n\n" );
    }

    if( !stricmp( argc[off], "brake" ) )
      badCommand = doStat( argn-off, argc+off, 1 );
    else
      if( !stricmp( argc[off], "stat" ) )
	badCommand = doStat( argn-off, argc+off );
      else
	if( !stricmp( argc[off], "summary" ) )
	  badCommand = doSum( argn-off, argc+off );
	else
	  if( !stricmp( argc[off], "reset" ) )
	    badCommand = doReset( argn-off, argc+off );
	  else
	    if( !stricmp( argc[off], "clear" ) )
	      badCommand = doClear( argn-off, argc+off );
	    else
	      if( !stricmp( argc[off], "merge" ) )
		badCommand = doMerge( argn-off, argc+off );
	      else
		if( !stricmp( argc[off], "help" ) )
		  badCommand = doHelp( prgName );
  }

  if( badCommand )
  {
    completeCode = 4;

    if( argn>1 )
    {
      if( badCommand!=2 )
      {
	puts( "*Fatal* Illegal command `" );
	for( int i=1; i<argn; i++ )
	{
	  puts( argc[i] );
	  if( i!=argn-1 )
	    putchar( ' ' );
	}
	puts( "'\n" );
      }
    }
    else
      puts( "*Fatal* No command specified!\n" );

    printf( "*Help* Please type `%s Help' for help\n", prgName );
  }

  returnToDos( completeCode );
}
