#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>

#include "busy.h"

const char *finitaLaComedia =
      "\n\04\04\04                                              \04\04\04\n"
      " \xfe ----======================================---- \xfe \n"
      " \xfe - Copyright (c) 1994 John Gladkih, 2:5051/16 - \xfe \n"
      " \xfe ----======================================---- \xfe \n"
      "\04\04\04                                              \04\04\04\n";

char *newStr( char *s )
{
  if( s==NULL )
    return NULL;

  char *n( new char [ strlen(s)+1 ] );

  strcpy( n, s );
  return n;
}

int hystTrail()
{

  if( fwrite( finitaLaComedia, 1, strlen(finitaLaComedia), hystFile )!=strlen(finitaLaComedia) )
    return 1;

  fwrite( finitaLaComedia, 1, 0, hystFile );

  return 0;

}

void makeHeaderCRC()
{
  register unsigned char *p( (unsigned char *)&hystHeader );
  hystHeader.crc = 0;
  for( size_t i=0; i<sizeof(hystHeader)-sizeof(hystHeader.crc); i++, p++ )
    hystHeader.crc += (unsigned short)*p;
}

void loadHystory( char *hystoryName )
{
  char * mode;

  if( access( hystoryName, 0 ) )
  {
    printf( "Initialize history file `%s'\n", hystoryName );
    mode = "w+b";
  }
  else
  {
    printf( "Loading history from file `%s'\n", hystoryName );
    mode = "r+b";
  }

  hystFile = fopen( hystoryName, mode );

  if( hystFile==NULL )
  {
    IOerror( hystoryName );
    returnToDos(5);
  }

  setbuf( hystFile, NULL );

  if( filelength( fileno( hystFile ) ) )
  {

    if( filelength( fileno( hystFile ) ) <
	 sizeof(hystHeader) + sizeof(info) +
         sizeof(totalNodes) + sizeof(totalIO) )
      goto format;

    if( fread( &hystHeader, 1, sizeof(hystHeader), hystFile )!=sizeof(hystHeader) )
    {
cant_load:
      char *msg( "Can't load history" );
      if( feof(hystFile) )
        printf( "*Fatal* %s - unexpected EOF\n", msg );
      else
        IOerror( msg );
      returnToDos(5);
    }

    if( memcmp( hystHeader.sign, hystHeaderSign, sizeof(hystHeader.sign) ) )
    {
format:
      printf( "*Fatal* Illegal history file format\n" );
      returnToDos(5);
    }

    unsigned short crc = hystHeader.crc;
    makeHeaderCRC();
    if( hystHeader.crc!=crc )
    {
      printf( "*Fatal* Illegal history file header CRC\n" );
      returnToDos(5);
    }

    if( fread( &hystInfo, 1, sizeof(hystInfo), hystFile )!=sizeof(hystInfo) )
      goto cant_load;

    if( fread( &hystTotalNodes, 1, sizeof(hystTotalNodes), hystFile )!=sizeof(hystTotalNodes) )
      goto cant_load;

    if( hystTotalNodes )
    {

      hystNodes = (NodeInfo **)malloc( sizeof(NodeInfo **)*hystTotalNodes );
      checkPtr( hystNodes );

      for( index j=0; j<hystTotalNodes; j++ )
      {

        NodeInfo *newNode( new NodeInfo );
        checkPtr( newNode );

	hystNodes[j] = newNode;

	if( fread( newNode, 1, sizeof(NodeInfo), hystFile )!=sizeof(NodeInfo) )
          goto cant_load;

        char len( 0 );

	if( fread( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
          goto cant_load;

        if( len )
        {
          newNode->domain = new char [len+1];
          checkPtr( newNode->domain );
	  if( fread( newNode->domain, 1, len, hystFile )!=len )
            goto cant_load;
          newNode->domain[len] = 0;
        }
        else
          newNode->domain = newStr( "" );

      }

    }

    if( fread( &hystTotalIO, 1, sizeof(hystTotalIO), hystFile )!=sizeof(hystTotalIO) )
      goto cant_load;

    if( hystTotalIO )
    {

      hystIoInfo = (IOInfo **)malloc( sizeof(IOInfo **)*hystTotalIO );
      checkPtr( hystIoInfo );

      for( index j=0; j<hystTotalIO; j++ )
      {

        IOInfo *newIO( new IOInfo );
        checkPtr( newIO );

	hystIoInfo[j] = newIO;

	if( fread( newIO, 1, sizeof(IOInfo), hystFile )!=sizeof(IOInfo) )
          goto cant_load;

        char len( 0 );

	if( fread( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
          goto cant_load;

        if( len )
        {
          newIO->name = new char [len+1];
          checkPtr( newIO->name );
	  if( fread( newIO->name, 1, len, hystFile )!=len )
            goto cant_load;
          newIO->name[len] = 0;
        }
        else
          newIO->name = newStr( "*Unloaded*" );

      }

    }

    for( int i=0, j=0; i<strlen(finitaLaComedia); i++ )
      if( (j=fgetc( hystFile ),j)==EOF || char(j)!=finitaLaComedia[i] )
        goto format;

    if( fgetc( hystFile )!=EOF )
    {
      printf( "*Fatal* Too long history file\n" );
      returnToDos(5);
    }

  }
  else
  {

    memset( &hystHeader, 0, sizeof(hystHeader) );
    memcpy( hystHeader.sign, hystHeaderSign, sizeof(hystHeader.sign) );

    makeHeaderCRC();

    fseek( hystFile, 0, SEEK_SET );

    if( fwrite( &hystHeader, 1, sizeof(hystHeader), hystFile )!=sizeof(hystHeader) )
    {
cant_init:
      IOerror( "Can't initialize hystory file" );
      returnToDos(5);
    }

    if( fwrite( &info, 1, sizeof(info), hystFile )!=sizeof(info) )
      goto cant_init;

    if( fwrite( &totalNodes, 1, sizeof(totalNodes), hystFile )!=sizeof(totalNodes) )
      goto cant_init;

    if( fwrite( &totalIO, 1, sizeof(totalIO), hystFile )!=sizeof(totalIO) )
      goto cant_init;

    if( hystTrail() )
      goto cant_init;

  }

}

void storeHystory()
{

  printf( "Storing history to file `%s'\n", hystName );

  fseek( hystFile, 0, SEEK_SET );

  if( fwrite( &hystHeader, 1, sizeof(hystHeader), hystFile )!=sizeof(hystHeader) )
  {
cant_store:
    IOerror( "Can't store history" );
    return;
  }

  if( fwrite( &info, 1, sizeof(info), hystFile )!=sizeof(info) )
    goto cant_store;

  if( fwrite( &totalNodes, 1, sizeof(totalNodes), hystFile )!=sizeof(totalNodes) )
    goto cant_store;

  for( index j=0; j<totalNodes; j++ )
  {

    if( fwrite( nodesInfo[j], 1, sizeof(NodeInfo), hystFile )!=sizeof(NodeInfo) )
      goto cant_store;

    char len( 0 );

    if( nodesInfo[j]->domain!=NULL )
      len = strlen( nodesInfo[j]->domain );

    if( fwrite( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
      goto cant_store;

    if( len )
      if( fwrite( nodesInfo[j]->domain, 1, len, hystFile )!=len )
        goto cant_store;

  }

  if( fwrite( &totalIO, 1, sizeof(totalIO), hystFile )!=sizeof(totalIO) )
    goto cant_store;

  for( j=0; j<totalIO; j++ )
  {

    if( fwrite( ioInfo[j], 1, sizeof(IOInfo), hystFile )!=sizeof(IOInfo) )
      goto cant_store;

    char len( 0 );

    if( ioInfo[j]->name!=NULL )
      len = strlen( ioInfo[j]->name );

    if( fwrite( &len, 1, sizeof(len), hystFile )!=sizeof(len) )
      goto cant_store;

    if( len )
      if( fwrite( ioInfo[j]->name, 1, len, hystFile )!=len )
        goto cant_store;

  }

  if( hystTrail() )
    goto cant_store;

}

inline void expandList( void **info, size_t size, index total, index hyst, char *m )
{
  if( total+hyst > MaxItems )
  {
    printf( "*Fatal* Too many items for merge %s lists, support up to %d\n", m, MaxItems );
    returnToDos( 6 );
  }
  *info = realloc( *info, size*(total+hyst) );
  checkPtr( *info );
}

void updateHystory()
{

  if( !hystHeader.init )
  {
    hystHeader.init = startTime;
    memcpy( hystHeader.hLogStart, logStart, sizeof(hystHeader.hLogStart) );
  }

  hystHeader.date = endTime;
  memcpy( hystHeader.hLogEnd, logEnd, sizeof(hystHeader.hLogEnd) );

  hystHeader.lines += logLines;
  hystHeader.size += fileSize;
  hystHeader.inSessions += inSessions;
  hystHeader.outSessions += outSessions;
  hystHeader.inHand += inHand;
  hystHeader.outHand += outHand;
  hystHeader.totalDialing += totalDialing;
  hystHeader.totalAnswering += totalAnswering;
  hystHeader.totalIncome += totalIncome;
  hystHeader.totalOutcome += totalOutcome;
  hystHeader.totalExternal += totalExternal;
  hystHeader.totalBytesIn += totalBytesIn;
  hystHeader.totalBytesOut += totalBytesOut;
  hystHeader.totalBBS += totalBBS;
  hystHeader.totalTerminal += totalTerminal;
  hystHeader.inMail += inMail;
  hystHeader.inXmail += inXmail;
  hystHeader.inFiles += inFiles;
  hystHeader.outMail += outMail;
  hystHeader.outXmail += outXmail;
  hystHeader.outFiles += outFiles;
  hystHeader.sesFTS0001 += sesFTS0001;
  hystHeader.sesWaZOO += sesWaZOO;
  hystHeader.sesEMSI += sesEMSI;

  makeHeaderCRC();

  for( int i=0; i<48; i++ )
  {

    info[i].dial += hystInfo[i].dial;
    info[i].answer += hystInfo[i].answer;

    info[i].income += hystInfo[i].income;
    info[i].outcome += hystInfo[i].outcome;

    info[i].external += hystInfo[i].external;
    info[i].bbs += hystInfo[i].bbs;
    info[i].terminal += hystInfo[i].terminal;

    info[i].usedCount += hystInfo[i].usedCount;

  }

  if( hystTotalNodes )
    if( totalNodes )
    {

      expandList( (void **)&nodesInfo, sizeof(NodeInfo **), totalNodes, hystTotalNodes, "node" );

      static unsigned int totalNodes1;

      for( index j=0; j<hystTotalNodes; j++ )
      {
        index old( totalNodes );

        totalNodes1 = totalNodes;
	NodeInfo **cur( (NodeInfo **)lsearch( hystNodes+j, nodesInfo,
          &totalNodes1, sizeof(NodeInfo **), addrCmp ) );
        totalNodes = totalNodes1;

        if( cur==NULL )
        {
          printf( "***Internal error lsearch()==NULL for node search\n"
                  "   Strange! Please report to Borland.\n" );
          returnToDos( 100 );
        }

        if( old==totalNodes )
        {
	  (*cur)->ioTime     += hystNodes[j]->ioTime;
	  (*cur)->sent       += hystNodes[j]->sent;
	  (*cur)->received   += hystNodes[j]->received;
	  (*cur)->income     += hystNodes[j]->income;
	  (*cur)->outcome    += hystNodes[j]->outcome;
	  (*cur)->inSession  += hystNodes[j]->inSession;
	  (*cur)->outSession += hystNodes[j]->outSession;
	  (*cur)->inMail     += hystNodes[j]->inMail;
	  (*cur)->inXmail    += hystNodes[j]->inXmail;
	  (*cur)->inFiles    += hystNodes[j]->inFiles;
	  (*cur)->outMail    += hystNodes[j]->outMail;
	  (*cur)->outXmail   += hystNodes[j]->outXmail;
	  (*cur)->outFiles   += hystNodes[j]->outFiles;
        }

      }

    }
    else
    {

      totalNodes = hystTotalNodes;
      nodesInfo = hystNodes;

    }

  if( hystTotalIO )
    if( totalIO )
    {

      expandList( (void **)&ioInfo, sizeof(IOInfo **), totalIO, hystTotalIO, "protocol" );

      static unsigned int totalIO1;

      for( index j=0; j<hystTotalIO; j++ )
      {
        index old( totalIO );

        totalIO1=totalIO;
	IOInfo **cur( (IOInfo**)lsearch( hystIoInfo+j, ioInfo, &totalIO1,
                                        sizeof(IOInfo **), io1Cmp ) );
        totalIO=totalIO1;

        if( cur==NULL )
        {
          printf( "***Internal error lsearch()==NULL for protocol search\n"
                  "   Strange! Please report to Borland.\n" );
          returnToDos( 100 );
        }

        if( old==totalIO )
	  (*cur)->count += hystIoInfo[j]->count;

      }

    }
    else
    {

      totalIO = hystTotalIO;
      ioInfo = hystIoInfo;

    }

}

void updateCounters()
{

  big how( endTime-startTime ),
      cur,
      from( startTime ),
      begin( startTime );

  struct time t;
  struct date d;

  unixtodos( begin, &d, &t );
  t.ti_hund = 0;
  t.ti_sec = 0;
  t.ti_min /= 30;
  int i = t.ti_hour*2 + t.ti_min;
  t.ti_min *= 30;

  begin = dostounix( &d, &t );

  while( how )
  {

    if( how>begin+30*60-from )
      cur = begin+30*60-from;
    else
      cur = how;

    info[i].usedCount++;

    if( ++i==48 )
      i = 0;

    begin += 30*60;
    how -= cur;
    from = begin;

  }

}
