#include <dos.h>
#include <io.h>
#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "jammb.h"
#include "jamsub.h"

void JamMsgInit( JAMAPIREC * pJam )
{
  memset( &pJam->Idx, 0, sizeof( JAMIDXREC ));
  pJam->Idx.UserCRC = ( UINT32 ) -1L;

  memset( &pJam->Hdr, 0, sizeof( JAMHDR ));

  pJam->Hdr.MsgIdCRC    = ( UINT32 ) -1L;
  pJam->Hdr.ReplyCRC    = ( UINT32 ) -1L;
  pJam->Hdr.PasswordCRC = ( UINT32 ) -1L;
}

void JamMsgDeinit( JAMAPIREC * pJam )
{
  memset( &pJam->Hdr, 0, sizeof( JAMHDR ));
}

void JamMsgAddSFldStr( JAMAPIREC * pJam, UINT16 SubFld, CHAR8 * Str, UINT32 * pSubFldPos )
{
  int Len = strlen( Str );

  if( !JAMmbAddField( pJam, SubFld, 1, strlen( Str ), pSubFldPos, Str ))
    printf( "*Warning* Work buffer for subfields to small.\n"
            "          Please report to John!\n" );

  switch( SubFld )
  {
  case JAMSFLD_RECVRNAME :
    strlwr( Str );
    pJam->Idx.UserCRC = JAMsysCrc32( Str, Len, ( UINT32 ) -1L );
    break;

  case JAMSFLD_MSGID :
    strlwr( Str );
    pJam->Hdr.MsgIdCRC = JAMsysCrc32( Str, Len, ( UINT32 ) -1L );
    break;

  case JAMSFLD_REPLYID :
    strlwr( Str );
    pJam->Hdr.ReplyCRC = JAMsysCrc32( Str, Len, ( UINT32 ) -1L );
    break;
  }

}

int JamMsgWrite( JAMAPIREC * pJam, CHAR8 * pMsgTxt )
{
  UINT32  MsgNo;
  int lckCnt = 0;
  char *fmt = "%79c\n";

  while( !JAMmbLockMsgBase( pJam, 1 ))
  {
    printf( "Try to lock JAM-base, press Esc to abort (%d)\r", ++lckCnt );

    if( kbhit() && getch()==27 )
    {
      printf( fmt, ' ' );
      printf( "*Error* JAM-base locking aborted by user\n" );
      return 0;
    }

    sleep( 1 );
  }

  if( lckCnt )
    printf( fmt, ' ' );

  MsgNo = ( filelength( pJam->IdxHandle ) / sizeof( JAMIDXREC )) + pJam->HdrInfo.BaseMsgNum;
  pJam->Hdr.MsgNum = MsgNo;
  pJam->Idx.HdrOffset = filelength( pJam->HdrHandle );
  pJam->Hdr.TxtOffset = filelength( pJam->TxtHandle );

  if( !JAMmbStoreMsgIdx( pJam, MsgNo ))
  {
    printf( "*Error* Can`t writing JAMIDXREC: %d\n", pJam->APImsg );
    return 0;
  }

  if( !JAMmbStoreMsgHdr( pJam, MsgNo ))
  {
    printf( "*Error* Can`t writing JAMHDR: %d\n", pJam->APImsg );
    return 0;
  }

  if( JAMsysWrite( NULL, pJam->HdrHandle, pJam->WorkBuf, ( int ) pJam->Hdr.SubfieldLen ) != ( int ) pJam->Hdr.SubfieldLen )
  {
    printf( "*Error* Can`t writing SubFields\n" );
    return 0;
  }

  if( !JAMmbStoreMsgTxtBuf( pJam, pMsgTxt, pJam->Hdr.TxtLen, 1 ))
  {
    printf( "*Error* Can`t writing message text: %d\n", pJam->APImsg );
    return 0;
  }

  pJam->HdrInfo.ActiveMsgs++;
  JAMmbUnLockMsgBase( pJam, 1 );

  return 1;
}
