#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <time.h>
#include <math.h>

#include "busy.h"

char *strTimeBig( big time )
{
  int secs( int(time%60) ),
      mins( int( (time/60)%60 ) ),
      hours( int( (time/60/60)%24 ) ),
      days( int( time/60/60/24 ) );
  char pflag( 0 ), *r( new char [ 60 ] ), w[32];

  checkPtr( r );
  *r = 0;

  if( days )
  {
    sprintf( w, "%d day%s ", days, suff( days ) );
    pflag = 1;
    strcat( r, w );
  }
  if( hours || pflag )
  {
    sprintf( w, "%d hour%s ", hours, suff( hours ) );
    pflag = 1;
    strcat( r, w );
  }
  if( mins || pflag )
  {
    sprintf( w, "%d min%s ", mins, suff( mins ) );
    pflag = 1;
    strcat( r, w );
  }
  sprintf( w, "%d sec%s", secs, suff( secs ) );
  strcat( r, w );

  return r;
}

char *strPerc( double dsize )
{
  char *r = new char[ 64 ];

  checkPtr( r );

  int len = sprintf( r, "%4.1f%%", dsize );

  if( r[len-2]=='0' )
  {
    r[len-3]=r[len-1];
    r[len-2]=0;
  }

  return r;
}

char *fullAddr( NodeInfo& node, int size )
{
  static char addr[64];

  sprintf( addr, "%u:%u/%u", node.zone, node.net, node.node);

  if( node.point )
  {
    char ppoint[8];
    sprintf( ppoint, ".%u",	node.point );
    strcat( addr, ppoint );
  }

/*
  if( *node.domain )
  {
    strcat( addr, "@" );
    strcat( addr, node.domain );
  }
*/  

  addr[size] = 0;

  return addr;
}

static near int maskMach( NodeInfo& node )
{
  if( nodeMask==NULL )
    return 1;

  char *addr( fullAddr( node, 63 ) );

  return regexec( nodeMask, addr );
}

inline index max( index a, index b )
{
  return a > b ? a : b;
}

static char tab[18][48];

static near  void setTab( int i, int& cur, int how, char ch )
{

  for( int j=0; j<how/100; j++ )
    if( j+cur>=18 )
    {
      printf( "*** Internal error: busy more then 100%% - %.1f in %d for %c\n"
	      "    Strange! Please report to John.\n",
	        (double(cur+how/100)/18)*100, i, ch );
      cur=17;
      return;
    }
    else
      tab[j+cur][i]=ch;

  cur += j;
}

static char *aStr, *bStr, *cStr, *dStr, *eStr, *fStr, *gStr;
static big elapsed, used;
static double totalSession, totalTraffic;

char extChar = '',
     conChar = '',
     sesChar = '',
     bbsChar = '',
     trmChar = '';

static near  void dumpStatHysto()
{

  memset( tab, ' ', sizeof(tab) );

  for( int i=0; i<48; i++ )
    if( info[i].usedCount )
    {
      int cur( 0 );
      double days( info[i].usedCount );
      setTab( i, cur, int(double(info[i].terminal)/days), trmChar );
      setTab( i, cur, int(double(info[i].bbs)/days), bbsChar );
      setTab( i, cur, int(double(info[i].external)/days), extChar );
      setTab( i, cur, int(double(info[i].answer+info[i].dial)/days), conChar);
      setTab( i, cur, int(double(info[i].income+info[i].outcome)/days), sesChar );
    }

  fputs( "Busy line\n", statFile );

  for( int j=0; j<18; j++ )
  {

    switch( j )
    {
    case 0:
      fprintf( statFile, "100% " );
      break;
    case 9:
      fprintf( statFile, " 50% " );
      break;
    default:
      fprintf( statFile, "      " );
      break;
    }

    for( i=0; i<48; i++ )
      if( (j==0 || j==9) && tab[17-j][i]==' ' )
	fputc( '', statFile );
      else
	fputc( tab[17-j][i], statFile );

    switch( j )
    {
    case 0:
      fputc( '', statFile );
      break;
    case 3:
      fprintf( statFile, "     Total busy   %5s",
               strPerc( double(used)/elapsed*100 )  );
      break;
    case 6:
      if( totalIncome+totalOutcome )
        fprintf( statFile, "       Sessions %c %5s",
	         sesChar,
                 strPerc( double(totalIncome+totalOutcome)/elapsed*100 ) );
      break;
    case 7:
      if( totalAnswering+totalDialing )
        fprintf( statFile, "    Answer/Dial %c %5s",
	         conChar,
                 strPerc( double(totalAnswering+totalDialing)/elapsed*100 ) );
      break;
    case 8:
      if( totalExternal )
        fprintf( statFile, "       External %c %5s",
	         extChar,
                 strPerc( double(totalExternal)/elapsed*100 ) );
      break;
    case 9:
      fprintf( statFile, "" );
      if( totalBBS )
        fprintf( statFile, "           BBS %c %5s",
	         bbsChar,
                 strPerc( double(totalBBS)/elapsed*100 ) );
      break;
    case 10:
      if( totalTerminal )
        fprintf( statFile, "       Terminal %c %5s",
    	         trmChar,
                 strPerc( double(totalTerminal)/elapsed*100 ) );
      break;
    case 13:
      fputs( "   ", statFile );
      for( i=0; i<17; i++ )
	fputc( '', statFile );
      fputc( '', statFile );
      break;
    case 14:
     {
      time_t curTime( time( NULL ) );
      char *tStr( ctime( &curTime) );
      tStr[ strlen(tStr)-1 ] = 0;
      strcpy( tStr+11, tStr+20 );
      fputs( "    ", statFile );
      fputs( tStr, statFile );
      fputs( " ", statFile );
     }
     break;
    case 15:
      fputs( "   ", statFile );
      for( i=0; i<17; i++ )
	fputc( '', statFile );
      fputc( '', statFile );
      break;
    }

    fputc( '\n', statFile );
  }

  fputs(  "  0% ", statFile );
  for( i=0; i<48; i++ )
    if( !(i%2) )
      fputc( '', statFile );
    else
      fputc( '', statFile );
  for( i=0; i<3; i++ )
    fputc( '', statFile );
  fputs( " Time of day", statFile );

  fputs( "\n       0 1 2 3 4 5 6 7 8 9 1011121314151617181920212223\n\n", statFile );

}

static near  void dumpStatTime()
{

  aStr = strTimeBig( elapsed );
  bStr = strTimeBig( used );
  fprintf( statFile, "  Elapsed %s\n  Used    %s\n\n", aStr, bStr );
  delete aStr;
  delete bStr;

  if( totalDialing+totalAnswering )
  {

    if( totalAnswering )
    {
      aStr = strTime( totalAnswering );
      fprintf( statFile, "  Answering %11s", aStr );
      delete aStr;
    }

    if( totalDialing )
    {
      dStr = strTime( totalDialing );
      fprintf( statFile, "%sialing   %11s",
               totalAnswering ? ",  d" : "  D",
               dStr );
      delete dStr;
    }

    fputc( '\n', statFile  );

  }

  if( totalIncome+totalOutcome )
  {

    if( totalIncome )
    {
      dStr = strTime( totalIncome ),
      fprintf( statFile, "  Incoming  %11s", dStr );
      delete dStr;
    }

    if( totalOutcome )
    {
      aStr = strTime( totalOutcome );
      fprintf( statFile, "%sutgoing  %11s",
                totalIncome ? ",  o" : "  O",
               aStr );
      delete aStr;
    }

    fputc( '\n', statFile  );

  }

  if( totalExternal+totalBBS+totalTerminal )
  {

    if( totalExternal )
    {
      dStr = strTime( totalExternal );
      fprintf( statFile, "  External  %11s", dStr );
      delete dStr;
    }

    if( totalBBS )
    {
      aStr = strTime( totalBBS );
      fprintf( statFile, "%sBBS       %11s",
               totalExternal  ? ",  " : "  ",
               aStr );
      delete aStr;
    }

    if( totalTerminal )
    {

      aStr = strTime( totalTerminal );
      fprintf( statFile, "%serminal  %11s",
               totalExternal+totalBBS ? ",  t" : "  T",
               aStr );
      delete aStr;

    }

    fputc( '\n', statFile  );

  }

  fputc( '\n', statFile  );

}

static near  void dumpStatTraffSum()
{

  char *tryFmt( "%6s  %6lu %6lu  %5s" ),
       *sesFmt( "  %8s %5lu  %5s" ),
       *ioFmt( "  %10s %5lu  %5s" );

  IOInfo *sesType[3];
  index totalType( 0 );

  if( sesEMSI )
  {
    checkPtr( sesType[totalType] = new IOInfo );
    sesType[totalType]->name = "EMSI";
    sesType[totalType]->count = sesEMSI;
    totalType++;
  }

  if( sesWaZOO )
  {
    checkPtr( sesType[totalType] = new IOInfo );
    sesType[totalType]->name = "WaZOO";
    sesType[totalType]->count = sesWaZOO;
    totalType++;
  }

  if( sesFTS0001 )
  {
    checkPtr( sesType[totalType] = new IOInfo );
    sesType[totalType]->name = "FTS-0001";
    sesType[totalType]->count = sesFTS0001;
    totalType++;
  }

  IOInfo *ansDial[2];
  index totalAD( 0 );

  if( inSessions )
  {
    checkPtr( ansDial[totalAD] = new IOInfo );
    ansDial[totalAD]->name = "Answer";
    ansDial[totalAD]->count = inHand;
    ansDial[totalAD]->total = inSessions;
    totalAD++;
  }

  if( outSessions )
  {
    checkPtr( ansDial[totalAD] = new IOInfo );
    ansDial[totalAD]->name = "Dial";
    ansDial[totalAD]->count = outHand;
    ansDial[totalAD]->total = outSessions;
    totalAD++;
  }

  if( totalAD || totalType || totalIO )
  {
    index lines( max( totalAD, max( totalType,totalIO ) ) );

    fputs( "\n  ", statFile );

    if( totalAD )
    {
      fputs( "         Total  Succs  Value", statFile );
      qsort( ansDial, totalAD, sizeof(IOInfo **), ioCmp );
    }

    if( totalType )
    {
      fputs( "           Total  Value", statFile );
      qsort( sesType, totalType, sizeof(IOInfo **), ioCmp );
    }

    if( totalIO )
    {
      fputs( "             Total  Value", statFile );
      qsort( ioInfo, totalIO, sizeof(IOInfo **), ioCmp );
    }

    fputs( "\n\n", statFile );

    for( index i=0; i<lines; i++ )
    {

      fputs( "  ", statFile );

      if( i<totalAD )
      {
        aStr = strPerc( double(ansDial[i]->count)/ansDial[i]->total*100 );
        fprintf( statFile, tryFmt,
          ansDial[i]->name, ansDial[i]->total, ansDial[i]->count, aStr );
        delete aStr;
      }
      else
        if( totalAD )
          fprintf( statFile, "%28c", ' ' );

      if( i<totalType )
      {
        aStr = strPerc( sesType[i]->count/totalSession*100 );
        fprintf( statFile, sesFmt,
          sesType[i]->name, sesType[i]->count, aStr );
        delete aStr;
      }
      else
        if( totalType )
          fprintf( statFile, "%23c", ' ' );

      if( i<totalIO )
      {
        aStr = strPerc( ioInfo[i]->count/totalSession*100 );
        fprintf( statFile, ioFmt,
          ioInfo[i]->name,
          ioInfo[i]->count, aStr );
        delete aStr;
      }

      fputc( '\n', statFile );

    }

  }

}

static near  void dumpStatTraffNodes()
{

  unsigned short curZone( 0 );

  if( totalNodes )
  {

    fprintf( statFile, "\n  Node           Sessions               Online               Traffic      CPS\n"
			 "               In/Out  Load       In/Out       Load     In/Out     Load\n\n" );

    curZone = 0;

    for( index i=0; i<totalNodes; i++ )
      if( maskMach( *nodesInfo[i] ) )
      {
	bStr = strBig( nodesInfo[i]->sent );
	cStr = strBig( nodesInfo[i]->received );
	aStr = strTime( nodesInfo[i]->income );
	dStr = strTime( nodesInfo[i]->outcome );
	eStr = strPerc( double(nodesInfo[i]->income+nodesInfo[i]->outcome)/
	       (totalIncome+totalOutcome)*100 );
	fStr = strPerc( double(nodesInfo[i]->inSession+nodesInfo[i]->outSession)/
	       totalSession*100 );
	gStr = strPerc( double(nodesInfo[i]->sent+nodesInfo[i]->received)/
	       totalTraffic*100 );

	if( curZone && curZone!=nodesInfo[i]->zone )
	  fputc( '\n', statFile );
	curZone = nodesInfo[i]->zone;

        big ioTime = nodesInfo[i]->ioTime;
        if( !ioTime )
          ioTime = 1;

	fprintf( statFile, "%-13s %3lu/%-3lu %5s %8s/%-8s %5s %6s/%-6s %5s %5d\n",
	  fullAddr( *nodesInfo[i], 13 ),
	  nodesInfo[i]->inSession, nodesInfo[i]->outSession, fStr,
	  aStr, dStr, eStr,
	  cStr, bStr, gStr,
          int(double(nodesInfo[i]->sent+nodesInfo[i]->received)/ioTime) );

	delete dStr;
	delete aStr;
	delete bStr;
	delete cStr;
	delete eStr;
	delete fStr;
	delete gStr;

      }

  }

}

static near  void dumpStatDetail()
{

  unsigned short curZone( 0 );

  if( totalTraffic )
    fprintf( statFile, "\n                       Received           Sent             Total\n\n" );

  char *trfFmt( "%-18s %7s  %5s   %7s  %5s   %7s  %5s\n" );

  if( outMail || inMail )
  {

    aStr = strBig( inMail );
    bStr = strBig( outMail );
    cStr = strPerc( inMail/totalTraffic*100 );
    dStr = strPerc( outMail/totalTraffic*100 );
    eStr = strBig( inMail+outMail );
    fStr = strPerc( (inMail+outMail)/totalTraffic*100 );

    fprintf( statFile, trfFmt,
      " * NetMail",
      aStr, cStr, bStr, dStr, eStr, fStr );

    if( useSess )
      fputc( '\n', statFile );

    delete fStr;
    delete eStr;
    delete dStr;
    delete cStr;
    delete bStr;
    delete aStr;

    if( useSess )
    {

      curZone = 0;

      for( index i=0; i<totalNodes; i++ )
	if( (nodesInfo[i]->outMail || nodesInfo[i]->inMail) && maskMach( *nodesInfo[i] ) )
	{
	  double totalNode( nodesInfo[i]->inMail+nodesInfo[i]->outMail );

	  aStr = strBig( nodesInfo[i]->inMail );
	  bStr = strBig( nodesInfo[i]->outMail );
	  cStr = strBig( totalNode );
	  dStr = strPerc( nodesInfo[i]->inMail/totalTraffic*100 );
	  eStr = strPerc( nodesInfo[i]->outMail/totalTraffic*100 );
	  fStr = strPerc( totalNode/totalTraffic*100 );

	  if( curZone && curZone!=nodesInfo[i]->zone )
	    fputc( '\n', statFile );
	  curZone = nodesInfo[i]->zone;

	  fprintf( statFile, trfFmt,
	    fullAddr( *nodesInfo[i], 16 ),
	    aStr, dStr, bStr, eStr, cStr, fStr );

	  delete dStr;
	  delete aStr;
	  delete bStr;
	  delete cStr;
	  delete eStr;
	  delete fStr;

	}

      fputc( '\n', statFile );

    }

  }

  if( outXmail || inXmail )
  {

    aStr = strBig( inXmail );
    bStr = strBig( outXmail );
    cStr = strPerc( inXmail/totalTraffic*100 );
    dStr = strPerc( outXmail/totalTraffic*100 );
    eStr = strBig( inXmail+outXmail );
    fStr = strPerc( (inXmail+outXmail)/totalTraffic*100 );

    fprintf( statFile, trfFmt,
      " * Xmail",
      aStr, cStr, bStr, dStr, eStr, fStr );

    if( useSess )
      fputc( '\n', statFile );

    delete fStr;
    delete eStr;
    delete dStr;
    delete cStr;
    delete bStr;
    delete aStr;

    if( useSess )
    {

      curZone = 0;

      for( index i=0; i<totalNodes; i++ )
	if( (nodesInfo[i]->outXmail || nodesInfo[i]->inXmail) && maskMach( *nodesInfo[i] ) )
	{
	  double totalNode( nodesInfo[i]->inXmail+nodesInfo[i]->outXmail );

	  aStr = strBig( nodesInfo[i]->inXmail );
	  bStr = strBig( nodesInfo[i]->outXmail );
	  cStr = strBig( totalNode );
	  dStr = strPerc( nodesInfo[i]->inXmail/totalTraffic*100 );
	  eStr = strPerc( nodesInfo[i]->outXmail/totalTraffic*100 );
	  fStr = strPerc( totalNode/totalTraffic*100 );

	  if( curZone && curZone!=nodesInfo[i]->zone )
	    fputc( '\n', statFile );
	  curZone = nodesInfo[i]->zone;

	  fprintf( statFile, trfFmt,
	    fullAddr( *nodesInfo[i], 16 ),
	    aStr, dStr, bStr, eStr, cStr, fStr );

	  delete dStr;
	  delete aStr;
	  delete bStr;
	  delete cStr;
	  delete eStr;
	  delete fStr;

	}

      fputc( '\n', statFile );

    }

  }

  if( outFiles || inFiles )
  {

    aStr = strBig( inFiles );
    bStr = strBig( outFiles );
    cStr = strPerc( inFiles/totalTraffic*100 );
    dStr = strPerc( outFiles/totalTraffic*100 );
    eStr = strBig( inFiles+outFiles );
    fStr = strPerc( (inFiles+outFiles)/totalTraffic * 100 );

    fprintf( statFile, trfFmt,
      " * Files",
      aStr, cStr, bStr, dStr, eStr, fStr );

    if( useSess )
      fputc( '\n', statFile );

    delete fStr;
    delete eStr;
    delete dStr;
    delete cStr;
    delete bStr;
    delete aStr;

    if( useSess )
    {

      curZone = 0;

      for( index i=0; i<totalNodes; i++ )
	if( (nodesInfo[i]->outFiles || nodesInfo[i]->inFiles) && maskMach( *nodesInfo[i] ) )
	{
	  double totalNode( nodesInfo[i]->inFiles+nodesInfo[i]->outFiles );

	  aStr = strBig( nodesInfo[i]->inFiles );
	  bStr = strBig( nodesInfo[i]->outFiles );
	  cStr = strBig( totalNode );
	  dStr = strPerc( nodesInfo[i]->inFiles/totalTraffic*100 );
	  eStr = strPerc( nodesInfo[i]->outFiles/totalTraffic*100 );
	  fStr = strPerc( totalNode/totalTraffic*100 );

	  if( curZone && curZone!=nodesInfo[i]->zone )
	    fputc( '\n', statFile );
	  curZone = nodesInfo[i]->zone;

	  fprintf( statFile, trfFmt,
	    fullAddr( *nodesInfo[i], 16 ),
	    aStr, dStr, bStr, eStr, cStr, fStr );

	  delete dStr;
	  delete aStr;
	  delete bStr;
	  delete cStr;
	  delete eStr;
	  delete fStr;

	}

      fputc( '\n', statFile );

    }

  }

}

void dumpStat( LOGStyle curLog )
{
  elapsed = endTime-startTime;
  used = totalDialing+totalAnswering+
         totalIncome+totalOutcome+
         totalExternal+totalBBS+
         totalTerminal;
  totalSession = inHand+outHand;
  totalTraffic = totalBytesIn+totalBytesOut;

  if( elapsed )
  {

    printf( "Writting statistics to file `%s'\n", statName );

    if( totalNodes )
      qsort( nodesInfo, totalNodes, sizeof(NodeInfo **), addrCmp );

    fprintf( statFile, "%c %s Statistics from %s to %s\n\n", 4,
      curLog==logTMStyle ?    "T-Mail" :
      curLog==logBinkStyle ?  "Bink/+" :
      curLog==logBrakeStyle ? "The Brake!" :
			      "Summary",
      logStart, logEnd );

    if( useHysto )
      dumpStatHysto();
    else
      fprintf( statFile, "  Total busy %5s\n\n", strPerc( double(used)/elapsed*100 ) );

    dumpStatTime();

    if( totalSession )
    {

      aStr = strPerc( inHand/totalSession*100 );
      bStr = strPerc( outHand/totalSession*100 );

      fprintf( statFile, "%c Complete %lu (%s) incoming and %lu (%s) outgoing session%s with %u node%s\n",
        4,
        inHand, aStr,
        outHand, bStr,
        suff( totalSession ),
        totalNodes, suff( totalNodes ) );

      delete aStr;
      delete bStr;

      dumpStatTraffSum();

      if( totalTraffic )
      {

        if( useTraff )
          dumpStatTraffNodes();

        dStr = strBig( totalBytesIn );
        aStr = strBig( totalBytesOut );
        bStr = strPerc( totalBytesOut/totalTraffic*100 );
        cStr = strPerc( totalBytesIn/totalTraffic*100 );

        fprintf( statFile, "\n%c Total %s (%s) received, %s (%s) sent\n",
	         4, dStr, cStr, aStr, bStr );

        delete dStr;
        delete aStr;
        delete bStr;
        delete cStr;

        dumpStatDetail();

      }
    }
  }

}

