#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <alloc.h>
#include <stdlib.h>

#include "busy.h"

const AnswerDefault = 30;

static near int tmGetLine()
{

  memset( line, 0, sizeof(line) );
  stamp = 0;

  for( ;; )
  {

    if( feof(logFile) )
      return 1;

    fgets( line, sizeof(line), logFile );

    progressBar();

    if( ferror(logFile) )
    {
      printf( "*Error* Unable to read T-Mail LOG file after line %lu - 0x%x\n", logLines, errno );
      printLine();
      return 1;
    }

    printLine( line );

    if( line[ strlen( line )-1 ]=='\n' )
      logLines++;

    stripLine( line );

    if( !*line )
    {
      skipLines++;
      continue;
    }

    if( !(isdigit(line[0]) && isdigit(line[1]) &&
        isdigit(line[3]) && isdigit(line[4]) &&
        isdigit(line[6]) && isdigit(line[7]) &&
        isdigit(line[9]) && isdigit(line[10]) &&
        isdigit(line[12]) && isdigit(line[13]) &&
        line[2]=='/' && line[5]==' ' && line[14]==' ' &&
        line[8]==':' && line[11]==':') )
    {
       printf( "*Warning* Illegal time format in line %lu\n", logLines );
       printLine();
       line[0]=0;
       continue;
    }

    int month = number( line+3 );
    struct date d, d1;
    struct time t;

    t.ti_hund = 0;
    t.ti_hour = number( line+6 );
    t.ti_min = number( line+9 );
    t.ti_sec = number( line+12 );
    d.da_mon = month;
    d.da_day = number( line );

    getdate( &d1 );
    d.da_year = d1.da_year;
    if( d1.da_mon<month )
      d.da_year--;

    big isTime = dostounix( &d, &t );

    if( isTime<=hystHeader.date )
    {
      skipLines++;
      line[0] = 0;
      startTime = isTime;
      continue;
    }

    memcpy( logEnd, line, 2 );
    logEnd[2] = ' ';
    memcpy( logEnd+3, monthName[ month-1 ], 3 );
    logEnd[6] = ' ';
    memcpy( logEnd+7, line+6, 8 );
    logEnd[ sizeof(logEnd)-1 ] = 0;

    if( !*logStart )
      strcpy( logStart, logEnd );

    endTime = isTime;

    if( !startTime )
      startTime = endTime;

    stamp = endTime;
    strcpy( line, line+15 );

    return 0;

  }

}

static near FileType tmPrsFileTypeIs( char *namePtr )
{

  namePtr = strchr( namePtr, '.' );

  if( namePtr++!=NULL )
    switch( toupper(*namePtr)+(toupper(*(namePtr+1))<<8) )
    {

    case 'MO':
    case 'WE':
    case 'TU':
    case 'FR':
    case 'TH':
    case 'SA':
    case 'SU':

      return Xmail;

    case 'PK':

     if( toupper(*(namePtr+2))=='T' || toupper(*(namePtr+2))=='H' )
       return Mail;
    }

  return Files;

}

static near big tmPrsSessionFileSize( FileType& fileType, char **protocol, big& delta )
{

  if( *protocol==NULL )
  {
    register char *prot( new char [ 9 ] );
    checkPtr( prot );
    char *patt( ",Dir" );

    if( begin( line+5, patt ) )
      memcpy( prot, patt+1, 3 );
    else
      memcpy( prot, "Zed", 3 );

    memcpy( prot+3, "Zap", 3 );
    memcpy( prot+6, line+3, 2 );
    prot[8]=0;

    *protocol = prot;

  }

  fileType = Undefined;

  big bytes = 0;
  char *namePtr = strchr( line, ' ' );

  if( namePtr==NULL )
  {
    printf( "*Error* Can't decode file type at line %lu\n", logLines );
    printLine();
    return 0;
  }

  namePtr++;

  char *sizePtr = strchr( namePtr, ' ' );

  if( sizePtr==NULL )
  {
err_size:
    printf( "*Error* Can't decode file length at line %lu\n", logLines );
    printLine();
    return 0;
  }

  *(sizePtr++) = 0;

  char *sizeEnd( strstr( sizePtr, " bytes" ) ),
       *patt( " bytes, from " ),
       *fromPtr( strstr( sizePtr, patt ) );

  if( sizeEnd==NULL )
    goto err_size;

  *sizeEnd = 0;
  bytes = strtoul( sizePtr, &sizeEnd, 10 );

  if( *sizeEnd )
    goto err_size;

  if( fromPtr!=NULL )
  {

    fromPtr += strlen( patt );
    delta = strtoul( fromPtr, &sizeEnd, 10 );

    if( *sizeEnd )
      goto err_size;

  }

  fileType = tmPrsFileTypeIs( namePtr );

  return bytes;

}

static near big tmPrsSessionFilePos( char *str, char *who, char end,
				     char *msg, char& isFound )
{
  char *found( strstr( str, who ) );

  isFound = 0;

  if( found==NULL )
    return 0;

  isFound = 1;

  char *sizeEnd;
  big bytes = strtoul( found+strlen(who), &sizeEnd, 10 );

  if( *sizeEnd!=end )
  {
    printf( "*Error* Can't decode %s position at line %lu\n", msg, logLines );
    printLine();
  }

  return bytes;
}

static near big tmPrsSessionNewFileSize( FileType& fileType, char **protocol, char janus )
{

  if( *protocol==NULL )
  {
    register char *prot( new char [ 9 ] );
    checkPtr( prot );

    if( !janus )
    {
      char *patt( ",Dir" );

      if( begin( line+5, patt ) )
	memcpy( prot, patt+1, 3 );
      else
	memcpy( prot, "Zed", 3 );

      memcpy( prot+3, "Zap", 3 );
      memcpy( prot+6, line+3, 2 );
      prot[8]=0;
    }
    else
    {
      memcpy( prot, "Janus", 6 );
      memcpy( prot+5, line+3, 2 );
      prot[7]=0;
    }

    *protocol = prot;
  }

  if( end( line, "skipped" ) )
  {
    fileType = Files;
    return 0;
  }

  fileType = Undefined;

  big bytes = 0;
  char *namePtr = strchr( line, ' ' );

  if( namePtr==NULL )
  {
    printf( "*Error* Can't decode file type at line %lu\n", logLines );
    printLine();
    return 0;
  }

  namePtr++;

  char *sizePtr = strchr( namePtr, ' ' );

  if( sizePtr==NULL )
  {
err_size:
    printf( "*Error* Can't decode file length at line %lu\n", logLines );
    printLine();
    return 0;
  }

  *(sizePtr++) = 0;

  fileType = tmPrsFileTypeIs( namePtr );

  char *statPtr = strchr( sizePtr, ' ' );

  if( statPtr==NULL )
  {
    printf( "*Error* Can't decode transfer state at line %lu\n", logLines );
    printLine();
    return 0;
  }

  *(statPtr++) = 0;

  char *sizeEnd;
  bytes = strtoul( sizePtr, &sizeEnd, 10 );

  if( *sizeEnd )
    goto err_size;

  char fromFound, toFound;
  long start( tmPrsSessionFilePos( statPtr, "(from ", ')', "start", fromFound ) ),
       at( tmPrsSessionFilePos( statPtr, "aborted at pos ", 0, "abort", toFound ) );

  start = (toFound ? at : bytes)-start;

  if( start<0 )
  {
    printf( "*** Internal problem: T-Mail Janus re-send logging BUG at %lu line\n"
	    "    Sorry! Please report to Andy Elkin.\n", logLines );
    printLine();
    start = bytes;
  }

  return start;
}

static near void tmPrsSession()
{

  big inTraf( 0 ),
      outTraf( 0 ),
      curIn( 0 ),
      curOut( 0 ),
      curDeltaIn( 0 ),
      curDeltaOut( 0 );

  big inMailL( 0 ),
      inXmailL( 0 ),
      inFilesL( 0 ),
      outMailL( 0 ),
      outXmailL( 0 ),
      outFilesL( 0 ),
      logOut( 0 ),
      logIn( 0 ),
      startIn( 0 ),
      startOut( 0 ),
      usedTime( 0 ),
      startPrev( stamp );

  char transferActive( 0 );

  FileType fileTypeIn( Undefined ),
	   fileTypeOut( Undefined );

  index curNode( 0xffff );
  big startLine( logLines );

  char *usingPtr( NULL ),
       *protocol( NULL ),
       *logTtlPtr( NULL );

  char *sendingFileMask( " Sending file " );
  char Emsi( 0 );

  for( ;; )
  {

    if( begin( line, " " ) &&
	( ( logTtlPtr=strstr( line, ", bytes" ) )!=NULL &&
	  strstr( line, ", time" )!=NULL ) )
    {

      logIn = strtoul( logTtlPtr+8, &logTtlPtr, 10 );

      if( *logTtlPtr!='/' )
      {
	printf( "*Error* Can't decode total received bytes at line %lu\n", logLines );
	printLine();
	logIn = 0;
      }
      else
      {

	logOut = strtoul( logTtlPtr+1, &logTtlPtr, 10 );

	if( *logTtlPtr!=',' )
	{
	  printf( "*Error* Can't decode total sent bytes at line %lu\n", logLines );
	  printLine();
	  logOut = 0;
	}

      }

      break;

    }

    if( begin( line, "Handshake failure" ) ||
	begin( line, "Human caller" ) )
      break;

    if( begin( line, "T-Mail" ) && ( strstr( line, "starting after" )!=NULL ||
				     strstr( line, "restoring from" )!=NULL ) )
      break;

    if( curNode==0xffff )
      if( (usingPtr=strstr( line, ", using " ))!=NULL )
      {
	char *addr = new char [int(usingPtr-line)+1];

	checkPtr( addr );

	*usingPtr = 0;
	strcpy( addr, line );

	unsigned short zone, net, node, point;
	char *domain;

	checkAddress( addr, zone, net, node, point, &domain );

	for( curNode=0; curNode<totalNodes; curNode++ )
	  if( nodesInfo[curNode]->point==point &&
	      nodesInfo[curNode]->node==node &&
	      nodesInfo[curNode]->net==net &&
	      nodesInfo[curNode]->zone==zone &&
	      !stricmp( nodesInfo[curNode]->domain, domain ) )
	    break;

	if( curNode==totalNodes )
	{

	  if( totalNodes==MaxItems )
	  {
	    printf( "*Fatal* Too many nodes! Support up to %u nodes.\n"
		    "        Sorry! Program aborted at line %lu :(\n", MaxItems, logLines );
	    printLine();
	    returnToDos( 1 );
	  }

	  curNode=totalNodes++;

	  nodesInfo = (NodeInfo **)realloc( nodesInfo,
	    totalNodes*sizeof(NodeInfo **) );
	  checkPtr( nodesInfo );

	  NodeInfo *newNode( new NodeInfo );
	  checkPtr( newNode );

	  memset( newNode, 0, sizeof(NodeInfo) );
	  nodesInfo[curNode] = newNode;

	  newNode->domain = new char[ strlen(domain) +1 ];
	  checkPtr( newNode->domain );
	  strcpy( newNode->domain, domain );

	  newNode->zone=zone;
	  newNode->net=net;
	  newNode->node=node;
	  newNode->point=point;

	}

      }

    if( begin( line, "JR-" ) )
    {
      transferActive = 1;
      curIn = tmPrsSessionNewFileSize( fileTypeIn, &protocol, 1 );

//      usedTime += stamp-(startIn?startIn:startPrev);
      inTraf += curIn;

      switch( fileTypeIn )
      {
      case Mail:
	inMailL += curIn;
	break;
      case Xmail:
	inXmailL += curIn;
	break;
      case Files:
	inFilesL += curIn;
	break;
      default:
	printf( "*** Internal error: Illegal received file type at %lu line\n"
		 "    Strange! Please report to John.\n", logLines );
	printLine();
      }

      startOut = stamp;
    }
    else
      if( begin( line, "JS-" ) )
      {
	transferActive = 1;
	curOut = tmPrsSessionNewFileSize( fileTypeOut, &protocol, 1 );

//	usedTime += stamp-(startOut?startOut:startPrev);
	outTraf += curOut;

	switch( fileTypeOut )
	{
	case Mail:
	  outMailL += curOut;
	  break;
	case Xmail:
	  outXmailL += curOut;
	  break;
	case Files:
	  outFilesL += curOut;
	  break;
	default:
	  printf( "*** Internal error: Illegal sent file type at %lu line\n"
		   "    Strange! Please report to John.\n", logLines );
	  printLine();
	}

	startOut = stamp;
      }
      else
	if( begin( line, "ZS-" ) )
	{
	  if( newTMail )
	  {
	    curOut = tmPrsSessionNewFileSize( fileTypeOut, &protocol, 0 );

//	    usedTime += stamp-(startOut?startOut:startPrev);
	    outTraf += curOut;

	    switch( fileTypeOut )
	    {
	    case Mail:
	      outMailL += curOut;
	      break;
	    case Xmail:
	      outXmailL += curOut;
	      break;
	    case Files:
	      outFilesL += curOut;
	      break;
	    default:
	      printf( "*** Internal error: Illegal sent file type at %lu line\n"
		       "    Strange! Please report to John.\n", logLines );
	      printLine();
	    }

	    startOut = stamp;
	  }
	  else
	  {
	    startOut = stamp;
	    curOut = tmPrsSessionFileSize( fileTypeOut, &protocol, curDeltaOut );
	  }
	  transferActive = 1;
	}
	else
	  if( begin( line, "ZR-" ) )
	  {
	    if( newTMail )
	    {
	      curIn = tmPrsSessionNewFileSize( fileTypeIn, &protocol, 0 );

//	      usedTime += stamp-(startIn?startIn:startPrev);
	      inTraf += curIn;

	      switch( fileTypeIn )
	      {
	      case Mail:
		inMailL += curIn;
		break;
	      case Xmail:
		inXmailL += curIn;
		break;
	      case Files:
		inFilesL += curIn;
		break;
	      default:
		printf( "*** Internal error: Illegal received file type at %lu line\n"
			 "    Strange! Please report to John.\n", logLines );
		printLine();
	      }

	      startOut = stamp;
	    }
	    else
	    {
	      startIn = stamp;
	      curIn = tmPrsSessionFileSize( fileTypeIn, &protocol, curDeltaIn );
	    }
	    transferActive = 1;
	  }
	  else
	    if( begin( line, "File sent." ) && !newTMail )
	    {
file_sent:
	      usedTime += stamp-(startOut?startOut:startPrev);
	      startOut = 0;
	      curOut -= curDeltaOut;
	      outTraf += curOut;

	      switch( fileTypeOut )
	      {
	      case Mail:
		outMailL += curOut;
		break;
	      case Xmail:
		outXmailL += curOut;
		break;
	      case Files:
		outFilesL += curOut;
		break;
	      default:
		printf("*** Internal error: Illegal sent file type at %lu line\n"
			"    Strange! Please report to John.\n", logLines );
		printLine();
	      }

	      fileTypeOut = Undefined;
	      curOut = 0;
	      curDeltaOut = 0;

	    }
	    else
	      if( begin( line, "File received." ) && !newTMail )
	      {
		usedTime += stamp-(startIn?startIn:startPrev);
		startIn = 0;
		curIn -= curDeltaIn;
		inTraf += curIn;

		switch( fileTypeIn )
		{
		case Mail:
		  inMailL += curIn;
		  break;
		case Xmail:
		  inXmailL += curIn;
		  break;
		case Files:
		  inFilesL += curIn;
		  break;
		default:
		  printf( "*** Internal error: Illegal received file type at %lu line\n"
			   "    Strange! Please report to John.\n", logLines );
		  printLine();
		}

		fileTypeIn = Undefined;
		curIn = 0;
		curDeltaIn = 0;

	      }
	      else
		if( begin( line, sendingFileMask ) && !newTMail  )
		{
		  char *patt( " aborted at pos " ),
		       *abortPos( strstr( line, patt ) );

		  if( abortPos==NULL )
bad_abort:
		  {
		    printf( "*Error* Can't decode abort position at line %lu\n", logLines );
		    printLine();
		  }
		  else
		  {
		    char *last( line );
		    abortPos += strlen(patt);
		    curOut = strtoul( abortPos, &last, 10 );
		    if( *last )
		      goto bad_abort;

		    if( fileTypeOut==Undefined )
		    {
		      *(abortPos-strlen(patt)) = 0;
		      fileTypeOut = tmPrsFileTypeIs( line+strlen(sendingFileMask) );
		    }

		  }

		  goto file_sent;
		}
		else
		  if( !newTMail && begin( line, "AKA" ) )
		    Emsi = 1;
		  else
		   if( !newTMail && begin( line, "Flags:" ) )
		     Emsi = 1;
		   else
		     if( newTMail && begin( line, "Handshake:" ) )
		     {
		       if( begin( line+11, "EMSI" ) )
			 Emsi = 1;
		       else
			if( begin( line+11, "YooHoo" ) )
			  Emsi = 0;
		     }

    if( !transferActive && newTMail  )
      startIn = stamp;

    startPrev = stamp;

    if( tmGetLine() )
    {
      getSkip = 1;
      tag = 1;
      break;
    }

  }

  if( protocol!=NULL )
  {
    registerIO( protocol );
    delete protocol;
  }

  if( !tag )
  {

    if( state==Incoming )
    {
      totalIncome += registerTime( stamp-actionStarted, Incoming );
      if( curNode!=0xffff )
	nodesInfo[curNode]->income += stamp-actionStarted;
    }
    else
    {
      totalOutcome += registerTime( stamp-actionStarted, Outcoming );
      if( curNode!=0xffff )
	nodesInfo[curNode]->outcome += stamp-actionStarted;
    }

  }

  if( logOut && logOut!=outTraf )
  {
    printf( "*** Internal error: LOG sent bytes not equal to counted at line %lu\n"
	    "    Strange! Please report to John.\n", logLines );
    printLine();
  }

  if( logIn && logIn!=inTraf )
  {

    if( !curIn || newTMail )
    {
      printf("*** Internal error: LOG received bytes not equal to counted at line %lu\n"
	     "    Strange! Please report to John.\n", logLines );
      printLine();
    }

    if( !newTMail )
    {
      usedTime += stamp-(startIn?startIn:startPrev);
      curIn = logIn-inTraf;
      inTraf += logIn;

      switch( fileTypeIn )
      {
      case Mail:
	inMailL += curIn;
	break;
      case Xmail:
	inXmailL += curIn;
	break;
      case Files:
	inFilesL += curIn;
	break;
      default:
	printf( "*** Internal error: Illegal received file type at %lu line\n"
		"    Strange! Please report to John.\n", logLines );
	printLine();
      }
    }
  }

  totalBytesIn += inTraf;
  inMail += inMailL;
  inXmail += inXmailL;
  inFiles += inFilesL;
  totalBytesOut += outTraf;
  outMail += outMailL;
  outXmail += outXmailL;
  outFiles += outFilesL;

  if( newTMail && startOut )
    usedTime += startOut-startIn;

  if( curNode!=0xffff )
  {

    nodesInfo[curNode]->received += inTraf;
    nodesInfo[curNode]->inMail += inMailL;
    nodesInfo[curNode]->inXmail += inXmailL;
    nodesInfo[curNode]->inFiles += inFilesL;

    nodesInfo[curNode]->sent += outTraf;
    nodesInfo[curNode]->outMail += outMailL;
    nodesInfo[curNode]->outXmail += outXmailL;
    nodesInfo[curNode]->outFiles += outFilesL;

    nodesInfo[curNode]->ioTime += usedTime;

    if( state==Incoming )
    {
      inHand++;
      nodesInfo[curNode]->inSession++;
    }
    else
    {
      outHand++;
      nodesInfo[curNode]->outSession++;
    }

    if( Emsi )
      sesEMSI++;
    else
      sesWaZOO++;
  }

  else
    if( inTraf+outTraf )
      printf("*** Internal error: nonzero traffic with undetected nodes at line %lu\n"
	     "    Strange! Please report to John.\n", startLine );

  state = noAction;

  if( !logIn && !logOut )
    if( tmGetLine() )
    {
      getSkip = 1;
      tag = 1;
    }
    else
      if( !(begin( line, " " ) &&
	    ( ( logTtlPtr=strstr( line, ", bytes" ) )!=NULL &&
	      strstr( line, ", time" )!=NULL ) ) )
	getSkip = 1;

}

static near void tmPrsTerminal()
{

  if( !begin( line, "Leaving terminal" ) )
    getSkip = 1;

  totalTerminal += registerTime( stamp-actionStarted,  terminalCalled );
  state = noAction;

}

static near void tmPrsEventExit()
{

  if( !begin( line, "Returned to T-Mail" ) )
    getSkip = 1;

  totalExternal += registerTime( stamp-actionStarted, Executing );
  state = noAction;

}

static int wasDialed = 0;

static near void tmPrsDialing()
{

  outSessions++;

  if( !begin( line, " Outgoing call:" ) )
  {
    getSkip = 1;
    state = noAction;

    if( wasDialed )
      totalDialing += registerTime( wasDialed, Dialing );
    else
      totalDialing += registerTime( AnswerDefault, Dialing );
  }
  else
  {
    if( wasDialed )
      totalDialing += registerTime( wasDialed, Dialing );
    else
      totalDialing += registerTime( stamp-actionStarted, Dialing );

    state = Outcoming;
  }

  wasDialed = 0;

}

static near void tmPrsAnsweringOld()
{

  inSessions++;
  getSkip = 1;
  totalAnswering += registerTime( AnswerDefault, Answering );
  state = Incoming;

}

static near void tmPrsAnswering()
{

  inSessions++;

  for( int done(0); !done; )
    if( begin( line, " Incoming call:" ) )
    {
      totalAnswering += registerTime( stamp-actionStarted, Answering );
      state = Incoming;
      done = 1;
    }
    else
      if( begin( line, " Incoming FAX call" ) )
      {
	totalAnswering += registerTime( stamp-actionStarted, Answering );
	inSessions--;
	state = FAXcall;
	done = 1;
      }
      else
	if( !begin( line, "CALLER'S NUMBER" ) )
	{
	  getSkip = 1;
	  totalAnswering += registerTime( AnswerDefault, Answering );
	  state = noAction;
	  done = 1;
	}
	else
	  if( tmGetLine() )
	  {
	    getSkip = 1;
	    tag = 1;
	    state = noAction;
	    done = 1;
	  }

}

static near void tmPrsExecuting()
{

  if( begin( line, "Returned to T-Mail" ) )
    totalExternal += registerTime( stamp-actionStarted, Executing );
  else
    getSkip = 1;

  state = noAction;
}

static near void tmPrsBBS()
{

  for( ;; )
    if( begin( line, "Returned to T-Mail" ) )
    {
      totalBBS += registerTime( stamp-actionStarted, BBS );
      break;
    }
    else
      if( !begin( line, "! Running" ) )
	break;
      else
	if( tmGetLine() )
	{
	  getSkip = 1;
	  tag = 1;
	  break;
	}

  state = noAction;

}

static near void tmPrsReceivedMail()
{

  while( line[0]=='#' || begin( line, "(Empty)" ) )
    tmGetLine();

  getSkip = 1;
  state = noAction;

}

static near void tmPrsFAXcall()
{
  inSessions++;
  inHand++;
  registerIO( "FAX In" );
  state = noAction;
}

static near prsState tmPrsBegin()
{

  actionStarted = stamp;

  if( begin( line, "Calling" ) || begin( line, "Polling" ) )
  {
    char *semi = strrchr( line, ':' );

    if( semi!=NULL )
    {
      char *end;

      wasDialed = (int)strtoul( semi+2, &end, 10 );

      if( !begin( end, " sec" ) )
      {
	wasDialed = 0;
/*
	printf( "*Error* Strange line %lu, expected `sec' at end of line\n",
		logLines );
	printLine();
*/
      }
    }

    return Dialing;
  }

  if( begin( line, "RING detected" ) )
    return Answering;

  if( begin( line, " Incoming call" ) )
    return oldTMAnswer;

  if( begin( line, "! Running" ) )
    return Executing;

  if( begin( line, "Loading BBS" ) )
    return BBS;

  if( begin( line, "Exiting," ) )
    return skipLine;                          //eventExit

  if( begin( line, "Exiting with errorlevel" ) )
    return skipLine;

  if( begin( line, "Frw. to" ) )
    return skipLine;

  if( begin( line, "Error: Unable to initialize modem" ) )
    return skipLine;

  if( begin( line, "Repacking" ) )
    return skipLine;

  if( begin( line, "Gen. msg" ) )
    return skipLine;

  if( begin( line, "Detected modem word" ) )
    return skipLine;

  if( begin( line, "Unable to initialize modem" ) )
    return skipLine;

  if( begin( line, "Returned to T-Mail" ) )
    return skipLine;

  if( begin( line, "Setting" ) )
    return skipLine;

  if( begin( line, " Flag" ) && strstr( line, "appeared." )!=NULL )
    return skipLine;

  if( begin( line, "T-Mail" ) && ( strstr( line, "starting after" )!=NULL ||
				   strstr( line, "restoring from" )!=NULL ) )
    return skipLine;

  if( begin( line, "Flag" ) && strstr( line, "killed." )!=NULL )
    return skipLine;

  if( begin( line, "Flag" ) && strstr( line, "created." )!=NULL )
    return skipLine;

  if( begin( line, "Created flag" ) )
    return skipLine;

  if( begin( line, "Killed flag" ) )
    return skipLine;

  if( begin( line, "Rescanning All netmail" ) )
    return skipLine;

  if( begin( line, " Appeared flag" ) )
    return skipLine;

  if( begin( line, "Starting DESQview" ) )
    return skipLine;

  if( begin( line, "Frw. msg" ) )
    return skipLine;

  if( begin( line, "Receiving Fax" ) )
    return skipLine;

  if( begin( line, "CALLER'S NUMBER" ) )
    return skipLine;

  if( begin( line, " Incoming FAX call." ) )
    return FAXcall;

  if( begin( line, "T-Mail" ) && strstr( line, "down from keyboard" )!=NULL )
    return skipLine;

  if( begin( line, "T-Mail" ) && strstr( line, "begin working" )!=NULL )
    return skipLine;

  if( begin( line, "T-Mail" ) && strstr( line, "exit with" )!=NULL )
    return skipLine;

  if( begin( line, "File" ) && strstr( line, "seems like echomail" )!=NULL )
    return skipLine;

  if( begin( line, "Unpacking" ) )
    return receivedMail;

  if( begin( line, "Entering terminal" ) )
    return terminalCalled;

  printf( "*Error* Unknown action beginning at line %lu\n", logLines );
  printLine();

  return noAction;

}

void tmParser()
{

  printf( "Processing T-Mail LOG `%s'", logName );

  if( !needProgressBar )
    putchar( '\n' );

  getSkip = 0;
  state = noAction;
  tag = 0;

  for( ;; )
  {

    if( tag )
      break;

    if( getSkip )
      getSkip = 0;
    else
      if( tmGetLine() )
	break;

    switch( state )
    {

    case noAction:
      state = tmPrsBegin();
      break;

    case Dialing:
      tmPrsDialing();
      break;

    case Answering:
      tmPrsAnswering();
      break;

    case oldTMAnswer:
      tmPrsAnsweringOld();
      break;

    case Incoming:
    case Outcoming:
      tmPrsSession();
      break;

    case Executing:
      tmPrsExecuting();
      break;

    case terminalCalled:
      tmPrsTerminal();
      break;

    case skipLine:
      state = noAction;
      getSkip = 1;
      break;

    case eventExit:
      tmPrsEventExit();
      break;

    case receivedMail:
      tmPrsReceivedMail();
      break;


    case BBS:
      tmPrsBBS();
      break;

    case FAXcall:
      tmPrsFAXcall();
      break;

    default:
      printf( "*Fatal* unknown parser state %d at line %lu\n",
	state, logLines );
      printLine();
      state = noAction;

    }

  }

  if( needProgressBar )
    printf( "      \n" );

  if( state!=noAction && state!=skipLine && state!=eventExit )
  {
    printf( "*Error* Incomplete file, parser finished with %d state\n", state );
    printLine();
  }

}

